# Angular用のInputManJSコンポーネント
このパッケージには、Angular用の[InputManJS](https://www.grapecity.co.jp/developer/inputmanjs)コンポーネントが含まれます。

[InputManJS](https://www.grapecity.co.jp/developer/inputmanjs)は、用途別に最適化された日本仕様の入力用JavaScriptコントロールセットです。文字種制限、日付書式、定型書式、コンボなど、あらゆるタイプの入力方式に対応し、リアルタイムな入力チェックといった機能も備えるため、入力ミスやストレスが少ない生産性の高い業務アプリケーションを開発できます。

## サンプル
[デモアプリケーション](https://demo.grapecity.com/inputmanjs/demos/)では、InputManJSを使用したアプリケーションの作成方法や、各コントロールの基本機能、実用的なアプリケーションの例などを紹介しています。

また、[トライアル版](https://www.grapecity.co.jp/developer/download#javascript)をダウンロードして、実際の機能や動作をご確認いただけます。

## インストール方法
```sh
npm install @grapecity/inputman.angular
```

## ドキュメント
製品の各種ドキュメントは、下記をご参照ください。
- [製品ヘルプ](https://demo.grapecity.com/inputmanjs/docs/)
- [チュートリアルデモ](https://demo.grapecity.com/inputmanjs/demos/)

## 製品情報
製品の詳細や価格、ライセンスについては、下記をご参照ください。

[https://www.grapecity.co.jp/developer/inputmanjs](https://www.grapecity.co.jp/developer/inputmanjs)
