(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@grapecity/inputman'), require('@angular/forms'), require('@angular/common')) :
  typeof define === 'function' && define.amd ? define('@grapecity/inputman.angular', ['exports', '@angular/core', '@grapecity/inputman', '@angular/forms', '@angular/common'], factory) :
  (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.grapecity = global.grapecity || {}, global.grapecity.inputman = global.grapecity.inputman || {}, global.grapecity.inputman.angular = {}), global.ng.core, global.GC, global.ng.forms, global.ng.common));
})(this, (function (exports, i0, GC, forms, common) { 'use strict';

  function _interopNamespace(e) {
    if (e && e.__esModule) return e;
    var n = Object.create(null);
    if (e) {
      Object.keys(e).forEach(function (k) {
        if (k !== 'default') {
          var d = Object.getOwnPropertyDescriptor(e, k);
          Object.defineProperty(n, k, d.get ? d : {
            enumerable: true,
            get: function () { return e[k]; }
          });
        }
      });
    }
    n["default"] = e;
    return Object.freeze(n);
  }

  var i0__namespace = /*#__PURE__*/_interopNamespace(i0);
  var GC__namespace = /*#__PURE__*/_interopNamespace(GC);

  /******************************************************************************
  Copyright (c) Microsoft Corporation.

  Permission to use, copy, modify, and/or distribute this software for any
  purpose with or without fee is hereby granted.

  THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
  REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
  AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
  INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
  LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
  OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
  PERFORMANCE OF THIS SOFTWARE.
  ***************************************************************************** */
  /* global Reflect, Promise */
  var extendStatics = function (d, b) {
      extendStatics = Object.setPrototypeOf ||
          ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
          function (d, b) { for (var p in b)
              if (Object.prototype.hasOwnProperty.call(b, p))
                  d[p] = b[p]; };
      return extendStatics(d, b);
  };
  function __extends(d, b) {
      if (typeof b !== "function" && b !== null)
          throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
      extendStatics(d, b);
      function __() { this.constructor = d; }
      d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
  }
  var __assign = function () {
      __assign = Object.assign || function __assign(t) {
          for (var s, i = 1, n = arguments.length; i < n; i++) {
              s = arguments[i];
              for (var p in s)
                  if (Object.prototype.hasOwnProperty.call(s, p))
                      t[p] = s[p];
          }
          return t;
      };
      return __assign.apply(this, arguments);
  };
  function __rest(s, e) {
      var t = {};
      for (var p in s)
          if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
              t[p] = s[p];
      if (s != null && typeof Object.getOwnPropertySymbols === "function")
          for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
              if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                  t[p[i]] = s[p[i]];
          }
      return t;
  }
  function __decorate(decorators, target, key, desc) {
      var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
      if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
          r = Reflect.decorate(decorators, target, key, desc);
      else
          for (var i = decorators.length - 1; i >= 0; i--)
              if (d = decorators[i])
                  r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
      return c > 3 && r && Object.defineProperty(target, key, r), r;
  }
  function __param(paramIndex, decorator) {
      return function (target, key) { decorator(target, key, paramIndex); };
  }
  function __esDecorate(ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
      function accept(f) { if (f !== void 0 && typeof f !== "function")
          throw new TypeError("Function expected"); return f; }
      var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
      var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
      var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
      var _, done = false;
      for (var i = decorators.length - 1; i >= 0; i--) {
          var context = {};
          for (var p in contextIn)
              context[p] = p === "access" ? {} : contextIn[p];
          for (var p in contextIn.access)
              context.access[p] = contextIn.access[p];
          context.addInitializer = function (f) { if (done)
              throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
          var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
          if (kind === "accessor") {
              if (result === void 0)
                  continue;
              if (result === null || typeof result !== "object")
                  throw new TypeError("Object expected");
              if (_ = accept(result.get))
                  descriptor.get = _;
              if (_ = accept(result.set))
                  descriptor.set = _;
              if (_ = accept(result.init))
                  initializers.unshift(_);
          }
          else if (_ = accept(result)) {
              if (kind === "field")
                  initializers.unshift(_);
              else
                  descriptor[key] = _;
          }
      }
      if (target)
          Object.defineProperty(target, contextIn.name, descriptor);
      done = true;
  }
  ;
  function __runInitializers(thisArg, initializers, value) {
      var useValue = arguments.length > 2;
      for (var i = 0; i < initializers.length; i++) {
          value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
      }
      return useValue ? value : void 0;
  }
  ;
  function __propKey(x) {
      return typeof x === "symbol" ? x : "".concat(x);
  }
  ;
  function __setFunctionName(f, name, prefix) {
      if (typeof name === "symbol")
          name = name.description ? "[".concat(name.description, "]") : "";
      return Object.defineProperty(f, "name", { configurable: true, value: prefix ? "".concat(prefix, " ", name) : name });
  }
  ;
  function __metadata(metadataKey, metadataValue) {
      if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
          return Reflect.metadata(metadataKey, metadataValue);
  }
  function __awaiter(thisArg, _arguments, P, generator) {
      function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
      return new (P || (P = Promise))(function (resolve, reject) {
          function fulfilled(value) { try {
              step(generator.next(value));
          }
          catch (e) {
              reject(e);
          } }
          function rejected(value) { try {
              step(generator["throw"](value));
          }
          catch (e) {
              reject(e);
          } }
          function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
          step((generator = generator.apply(thisArg, _arguments || [])).next());
      });
  }
  function __generator(thisArg, body) {
      var _ = { label: 0, sent: function () { if (t[0] & 1)
              throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
      return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
      function verb(n) { return function (v) { return step([n, v]); }; }
      function step(op) {
          if (f)
              throw new TypeError("Generator is already executing.");
          while (g && (g = 0, op[0] && (_ = 0)), _)
              try {
                  if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                      return t;
                  if (y = 0, t)
                      op = [op[0] & 2, t.value];
                  switch (op[0]) {
                      case 0:
                      case 1:
                          t = op;
                          break;
                      case 4:
                          _.label++;
                          return { value: op[1], done: false };
                      case 5:
                          _.label++;
                          y = op[1];
                          op = [0];
                          continue;
                      case 7:
                          op = _.ops.pop();
                          _.trys.pop();
                          continue;
                      default:
                          if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                              _ = 0;
                              continue;
                          }
                          if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                              _.label = op[1];
                              break;
                          }
                          if (op[0] === 6 && _.label < t[1]) {
                              _.label = t[1];
                              t = op;
                              break;
                          }
                          if (t && _.label < t[2]) {
                              _.label = t[2];
                              _.ops.push(op);
                              break;
                          }
                          if (t[2])
                              _.ops.pop();
                          _.trys.pop();
                          continue;
                  }
                  op = body.call(thisArg, _);
              }
              catch (e) {
                  op = [6, e];
                  y = 0;
              }
              finally {
                  f = t = 0;
              }
          if (op[0] & 5)
              throw op[1];
          return { value: op[0] ? op[1] : void 0, done: true };
      }
  }
  var __createBinding = Object.create ? (function (o, m, k, k2) {
      if (k2 === undefined)
          k2 = k;
      var desc = Object.getOwnPropertyDescriptor(m, k);
      if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
          desc = { enumerable: true, get: function () { return m[k]; } };
      }
      Object.defineProperty(o, k2, desc);
  }) : (function (o, m, k, k2) {
      if (k2 === undefined)
          k2 = k;
      o[k2] = m[k];
  });
  function __exportStar(m, o) {
      for (var p in m)
          if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
              __createBinding(o, m, p);
  }
  function __values(o) {
      var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
      if (m)
          return m.call(o);
      if (o && typeof o.length === "number")
          return {
              next: function () {
                  if (o && i >= o.length)
                      o = void 0;
                  return { value: o && o[i++], done: !o };
              }
          };
      throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
  }
  function __read(o, n) {
      var m = typeof Symbol === "function" && o[Symbol.iterator];
      if (!m)
          return o;
      var i = m.call(o), r, ar = [], e;
      try {
          while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
              ar.push(r.value);
      }
      catch (error) {
          e = { error: error };
      }
      finally {
          try {
              if (r && !r.done && (m = i["return"]))
                  m.call(i);
          }
          finally {
              if (e)
                  throw e.error;
          }
      }
      return ar;
  }
  /** @deprecated */
  function __spread() {
      for (var ar = [], i = 0; i < arguments.length; i++)
          ar = ar.concat(__read(arguments[i]));
      return ar;
  }
  /** @deprecated */
  function __spreadArrays() {
      for (var s = 0, i = 0, il = arguments.length; i < il; i++)
          s += arguments[i].length;
      for (var r = Array(s), k = 0, i = 0; i < il; i++)
          for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
              r[k] = a[j];
      return r;
  }
  function __spreadArray(to, from, pack) {
      if (pack || arguments.length === 2)
          for (var i = 0, l = from.length, ar; i < l; i++) {
              if (ar || !(i in from)) {
                  if (!ar)
                      ar = Array.prototype.slice.call(from, 0, i);
                  ar[i] = from[i];
              }
          }
      return to.concat(ar || Array.prototype.slice.call(from));
  }
  function __await(v) {
      return this instanceof __await ? (this.v = v, this) : new __await(v);
  }
  function __asyncGenerator(thisArg, _arguments, generator) {
      if (!Symbol.asyncIterator)
          throw new TypeError("Symbol.asyncIterator is not defined.");
      var g = generator.apply(thisArg, _arguments || []), i, q = [];
      return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
      function verb(n) { if (g[n])
          i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
      function resume(n, v) { try {
          step(g[n](v));
      }
      catch (e) {
          settle(q[0][3], e);
      } }
      function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
      function fulfill(value) { resume("next", value); }
      function reject(value) { resume("throw", value); }
      function settle(f, v) { if (f(v), q.shift(), q.length)
          resume(q[0][0], q[0][1]); }
  }
  function __asyncDelegator(o) {
      var i, p;
      return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
      function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: false } : f ? f(v) : v; } : f; }
  }
  function __asyncValues(o) {
      if (!Symbol.asyncIterator)
          throw new TypeError("Symbol.asyncIterator is not defined.");
      var m = o[Symbol.asyncIterator], i;
      return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
      function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
      function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
  }
  function __makeTemplateObject(cooked, raw) {
      if (Object.defineProperty) {
          Object.defineProperty(cooked, "raw", { value: raw });
      }
      else {
          cooked.raw = raw;
      }
      return cooked;
  }
  ;
  var __setModuleDefault = Object.create ? (function (o, v) {
      Object.defineProperty(o, "default", { enumerable: true, value: v });
  }) : function (o, v) {
      o["default"] = v;
  };
  function __importStar(mod) {
      if (mod && mod.__esModule)
          return mod;
      var result = {};
      if (mod != null)
          for (var k in mod)
              if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                  __createBinding(result, mod, k);
      __setModuleDefault(result, mod);
      return result;
  }
  function __importDefault(mod) {
      return (mod && mod.__esModule) ? mod : { default: mod };
  }
  function __classPrivateFieldGet(receiver, state, kind, f) {
      if (kind === "a" && !f)
          throw new TypeError("Private accessor was defined without a getter");
      if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
          throw new TypeError("Cannot read private member from an object whose class did not declare it");
      return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
  }
  function __classPrivateFieldSet(receiver, state, value, kind, f) {
      if (kind === "m")
          throw new TypeError("Private method is not writable");
      if (kind === "a" && !f)
          throw new TypeError("Private accessor was defined without a setter");
      if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
          throw new TypeError("Cannot write private member to an object whose class did not declare it");
      return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
  }
  function __classPrivateFieldIn(state, receiver) {
      if (receiver === null || (typeof receiver !== "object" && typeof receiver !== "function"))
          throw new TypeError("Cannot use 'in' operator on non-object");
      return typeof state === "function" ? receiver === state : state.has(receiver);
  }
  var tslib_es6 = {
      __extends: __extends,
      __assign: __assign,
      __rest: __rest,
      __decorate: __decorate,
      __param: __param,
      __metadata: __metadata,
      __awaiter: __awaiter,
      __generator: __generator,
      __createBinding: __createBinding,
      __exportStar: __exportStar,
      __values: __values,
      __read: __read,
      __spread: __spread,
      __spreadArrays: __spreadArrays,
      __spreadArray: __spreadArray,
      __await: __await,
      __asyncGenerator: __asyncGenerator,
      __asyncDelegator: __asyncDelegator,
      __asyncValues: __asyncValues,
      __makeTemplateObject: __makeTemplateObject,
      __importStar: __importStar,
      __importDefault: __importDefault,
      __classPrivateFieldGet: __classPrivateFieldGet,
      __classPrivateFieldSet: __classPrivateFieldSet,
      __classPrivateFieldIn: __classPrivateFieldIn,
  };

  var IMCtrl = "__imctrl";
  function Property(setter, getter, isPramArr, supportWithinConfig, order) {
      var saveToTargetProDic = function (target, propertyName) {
          var methods = {
              setter: setter,
              getter: getter,
              isPramArr: isPramArr,
              supportWithinConfig: (typeof supportWithinConfig === "boolean") ? supportWithinConfig : true,
              order: (typeof order === "number") ? order : -1
          };
          if (!target.propDic) {
              target.propDic = {};
          }
          target.propDic[propertyName] = methods;
      };
      return saveToTargetProDic;
  }
  var isEmpty = function (value) {
      return value === undefined || value === null || value === "";
  };
  var getMethodPrefix = function (type) {
      if (type === MethodType.getter) {
          return "get";
      }
      else if (type === MethodType.setter) {
          return "set";
      }
  };
  var MethodType;
  (function (MethodType) {
      MethodType[MethodType["getter"] = 0] = "getter";
      MethodType[MethodType["setter"] = 1] = "setter";
  })(MethodType || (MethodType = {}));

  function provideParent(component) {
      return { provide: GcComponents, useExisting: i0.forwardRef(function () { return component; }) };
  }
  var GcComponents = /** @class */ (function () {
      function GcComponents(ref) {
          this.onInitialized = new i0.EventEmitter();
          this._container = ref.nativeElement;
      }
      GcComponents.prototype.ngOnChanges = function (changes) {
          var _this = this;
          if (!this._imCtrl) {
              return;
          }
          Object.keys(changes).forEach(function (key) {
              var currentValue = changes[key].currentValue;
              _this.setValueToIMControl(key, currentValue);
          });
      };
      GcComponents.prototype.setValueToIMControl = function (key, value) {
          if (value === undefined) {
              return;
          }
          if (this.isSetAccessor(key)) {
              this._imCtrl[key] = value;
              return;
          }
          var setter = this.tryGetPropertyOperator(key, MethodType.setter);
          if (this.hasRealMethod(setter)) {
              if (this.propDic && this.propDic[key] && this.propDic[key].isPramArr === true) {
                  this._imCtrl[setter].apply(this._imCtrl, value);
              }
              else {
                  this._imCtrl[setter](value);
              }
          }
      };
      GcComponents.prototype.isSetAccessor = function (key, prototype) {
          if (prototype === void 0) { prototype = Object.getPrototypeOf(this._imCtrl); }
          var descriptor = Object.getOwnPropertyDescriptor(prototype, key);
          if (descriptor && descriptor.set) {
              return true;
          }
          else {
              prototype = Object.getPrototypeOf(prototype);
              if (prototype) {
                  return this.isSetAccessor(key, prototype);
              }
          }
          return false;
      };
      GcComponents.prototype.ngOnDestroy = function () {
          if (this._container != null) {
              this._container.remove();
          }
      };
      GcComponents.prototype.ngAfterContentInit = function () {
          var _this = this;
          this.initGcComponent();
          if (typeof this._imCtrl === 'object') {
              this.onInitialized.emit(this._imCtrl);
          }
          this.bindEvent();
          if (this.propDic) {
              var unSupportWithinConfigProps = Object.keys(this.propDic).filter(function (p) { return _this.propDic[p] && _this.propDic[p].supportWithinConfig === false; });
              unSupportWithinConfigProps.sort(function (p1, p2) {
                  return _this.propDic[p1].order - _this.propDic[p2].order;
              });
              unSupportWithinConfigProps.forEach(function (p) {
                  _this.setValueToIMControl(p, _this[p]);
              });
          }
          this._container[IMCtrl] = this._imCtrl;
      };
      GcComponents.prototype.tryGetPropertyOperator = function (propertyName, methodType) {
          var method = "";
          if (this.propDic && this.propDic[propertyName]) {
              method = methodType === MethodType.getter ? this.propDic[propertyName].getter : this.propDic[propertyName].setter;
              if (!isEmpty(method)) {
                  return method;
              }
          }
          return getMethodPrefix(methodType) + propertyName[0].toUpperCase() + propertyName.slice(1);
      };
      GcComponents.prototype.hasRealMethod = function (methodName) {
          return this._imCtrl && typeof this._imCtrl[methodName] === "function";
      };
      GcComponents.prototype.getNestedIMControl = function () {
          return this._imCtrl;
      };
      GcComponents.prototype.createTemplate = function (element) {
          this._container.appendChild(element);
          if (element && this.name) {
              element.setAttribute('name', this.name);
          }
      };
      return GcComponents;
  }());
  GcComponents.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcComponents, deps: [{ token: i0__namespace.ElementRef }], target: i0__namespace.ɵɵFactoryTarget.Component });
  GcComponents.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.17", type: GcComponents, selector: "ng-component", inputs: { name: "name" }, outputs: { onInitialized: "onInitialized" }, usesOnChanges: true, ngImport: i0__namespace, template: '', isInline: true });
  i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcComponents, decorators: [{
              type: i0.Component,
              args: [{
                      template: ''
                  }]
          }], ctorParameters: function () { return [{ type: i0__namespace.ElementRef }]; }, propDecorators: { name: [{
                  type: i0.Input
              }], onInitialized: [{
                  type: i0.Output
              }] } });

  var GcCalculatorComponent = /** @class */ (function (_super) {
      __extends(GcCalculatorComponent, _super);
      function GcCalculatorComponent(ref) {
          return _super.call(this, ref) || this;
      }
      GcCalculatorComponent.prototype.initGcComponent = function () {
          var element = document.createElement('div');
          this.createTemplate(element);
          this._imCtrl = new GC__namespace.InputMan.GcCalculator(element, this);
      };
      GcCalculatorComponent.prototype.bindEvent = function () { };
      return GcCalculatorComponent;
  }(GcComponents));
  GcCalculatorComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcCalculatorComponent, deps: [{ token: i0__namespace.ElementRef }], target: i0__namespace.ɵɵFactoryTarget.Component });
  GcCalculatorComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.17", type: GcCalculatorComponent, selector: "gc-calculator", inputs: { value: "value", showOutput: "showOutput", visible: "visible", enabled: "enabled", buttonText: "buttonText" }, usesInheritance: true, ngImport: i0__namespace, template: "", isInline: true });
  i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcCalculatorComponent, decorators: [{
              type: i0.Component,
              args: [{
                      selector: 'gc-calculator',
                      template: ""
                  }]
          }], ctorParameters: function () { return [{ type: i0__namespace.ElementRef }]; }, propDecorators: { value: [{
                  type: i0.Input
              }], showOutput: [{
                  type: i0.Input
              }], visible: [{
                  type: i0.Input
              }], enabled: [{
                  type: i0.Input
              }], buttonText: [{
                  type: i0.Input
              }] } });

  var GcCalendarComponent = /** @class */ (function (_super) {
      __extends(GcCalendarComponent, _super);
      function GcCalendarComponent(ref) {
          var _this = _super.call(this, ref) || this;
          _this.onClickDate = new i0.EventEmitter();
          _this.onScrolled = new i0.EventEmitter();
          _this.onFocusDateChanged = new i0.EventEmitter();
          _this.onSelectedDateChanged = new i0.EventEmitter();
          // For V2.1 Compatibility, we have to keep this property or event
          _this.focusDateChange = new i0.EventEmitter();
          _this.selectedDateChange = new i0.EventEmitter();
          return _this;
      }
      GcCalendarComponent.prototype.writeValue = function (value) {
          if (this.selectionMode == undefined || this.selectionMode == GC__namespace.InputMan.CalendarSelectionMode.One) {
              this.selectedDate = value;
              if (this._imCtrl) {
                  this._imCtrl.selectedDate = this.selectedDate;
              }
          }
          else {
              if (this._imCtrl) {
                  if (value instanceof Array) {
                      this._imCtrl.setSelections(value);
                  }
                  else {
                      this._imCtrl.setSelections([value]);
                  }
              }
          }
      };
      GcCalendarComponent.prototype.registerOnChange = function (onChange) {
          this.onChange = onChange;
      };
      GcCalendarComponent.prototype.registerOnTouched = function (onTouched) {
          this.onTouched = onTouched;
      };
      GcCalendarComponent.prototype.setDisabledState = function (isDisabled) {
          this._imCtrl.enabled = !isDisabled;
      };
      GcCalendarComponent.prototype.initGcComponent = function () {
          var element = document.createElement('div');
          this.createTemplate(element);
          if (Array.isArray(this.calendarDimensions)) {
              this.calendarDimensions = {
                  width: this.calendarDimensions[0],
                  height: this.calendarDimensions[1]
              };
          }
          this._imCtrl = new GC__namespace.InputMan.GcCalendar(element, this);
      };
      GcCalendarComponent.prototype.bindEvent = function () {
          var _this = this;
          if (!this._imCtrl) {
              return;
          }
          this._imCtrl.onClickDate(function (s) { _this.onClickDate.emit(s); });
          this._imCtrl.onScrolled(function (s) { _this.onScrolled.emit(s); });
          this._imCtrl.onFocusDateChanged(function (s) {
              _this.onFocusDateChanged.emit(s);
              _this.focusDateChange.emit(s.getFocusDate());
          });
          this._imCtrl.onSelectedDateChanged(function (s) {
              _this.onSelectedDateChanged.emit(s);
              if (_this._imCtrl.selectionMode == GC__namespace.InputMan.CalendarSelectionMode.One) {
                  _this.onChange(s.getSelectedDate());
              }
              else {
                  _this.onChange(s.getSelections());
              }
              _this.onTouched();
              _this.selectedDateChange.emit(s.getSelectedDate());
          });
      };
      return GcCalendarComponent;
  }(GcComponents));
  GcCalendarComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcCalendarComponent, deps: [{ token: i0__namespace.ElementRef }], target: i0__namespace.ɵɵFactoryTarget.Component });
  GcCalendarComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.17", type: GcCalendarComponent, selector: "gc-calendar", inputs: { visible: "visible", maxSelectionCount: "maxSelectionCount", selectionMode: "selectionMode", selectedDate: "selectedDate", enabled: "enabled", weekTitleSelect: "weekTitleSelect", weekNumberSelect: "weekNumberSelect", focusDate: "focusDate", maxDate: "maxDate", minDate: "minDate", allowSelection: "allowSelection", emptyRows: "emptyRows", firstDayOfWeek: "firstDayOfWeek", firstFiscalMonth: "firstFiscalMonth", firstMonthInView: "firstMonthInView", yearMonthFormat: "yearMonthFormat", headerFormat: "headerFormat", showZoomButton: "showZoomButton", showRokuyou: "showRokuyou", showHeader: "showHeader", showToday: "showToday", showWeekNumber: "showWeekNumber", showTrailing: "showTrailing", calendarYear: "calendarYear", showNavigator: "showNavigator", navigatorOrientation: "navigatorOrientation", overrideTipText: "overrideTipText", calendarType: "calendarType", calendarDimensions: "calendarDimensions", scrollRate: "scrollRate" }, outputs: { onClickDate: "onClickDate", onScrolled: "onScrolled", onFocusDateChanged: "onFocusDateChanged", onSelectedDateChanged: "onSelectedDateChanged", focusDateChange: "focusDateChange", selectedDateChange: "selectedDateChange" }, providers: [
          {
              provide: forms.NG_VALUE_ACCESSOR,
              multi: true,
              useExisting: i0.forwardRef(function () { return GcCalendarComponent; }),
          }
      ], usesInheritance: true, ngImport: i0__namespace, template: "", isInline: true });
  __decorate([
      Property("setCalendarDimensions", "", true),
      __metadata("design:type", Array)
  ], GcCalendarComponent.prototype, "calendarDimensions", void 0);
  i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcCalendarComponent, decorators: [{
              type: i0.Component,
              args: [{
                      selector: 'gc-calendar',
                      template: "",
                      providers: [
                          {
                              provide: forms.NG_VALUE_ACCESSOR,
                              multi: true,
                              useExisting: i0.forwardRef(function () { return GcCalendarComponent; }),
                          }
                      ]
                  }]
          }], ctorParameters: function () { return [{ type: i0__namespace.ElementRef }]; }, propDecorators: { visible: [{
                  type: i0.Input
              }], maxSelectionCount: [{
                  type: i0.Input
              }], selectionMode: [{
                  type: i0.Input
              }], selectedDate: [{
                  type: i0.Input
              }], enabled: [{
                  type: i0.Input
              }], weekTitleSelect: [{
                  type: i0.Input
              }], weekNumberSelect: [{
                  type: i0.Input
              }], focusDate: [{
                  type: i0.Input
              }], maxDate: [{
                  type: i0.Input
              }], minDate: [{
                  type: i0.Input
              }], allowSelection: [{
                  type: i0.Input
              }], emptyRows: [{
                  type: i0.Input
              }], firstDayOfWeek: [{
                  type: i0.Input
              }], firstFiscalMonth: [{
                  type: i0.Input
              }], firstMonthInView: [{
                  type: i0.Input
              }], yearMonthFormat: [{
                  type: i0.Input
              }], headerFormat: [{
                  type: i0.Input
              }], showZoomButton: [{
                  type: i0.Input
              }], showRokuyou: [{
                  type: i0.Input
              }], showHeader: [{
                  type: i0.Input
              }], showToday: [{
                  type: i0.Input
              }], showWeekNumber: [{
                  type: i0.Input
              }], showTrailing: [{
                  type: i0.Input
              }], calendarYear: [{
                  type: i0.Input
              }], showNavigator: [{
                  type: i0.Input
              }], navigatorOrientation: [{
                  type: i0.Input
              }], overrideTipText: [{
                  type: i0.Input
              }], calendarType: [{
                  type: i0.Input
              }], calendarDimensions: [{
                  type: i0.Input
              }], scrollRate: [{
                  type: i0.Input
              }], onClickDate: [{
                  type: i0.Output
              }], onScrolled: [{
                  type: i0.Output
              }], onFocusDateChanged: [{
                  type: i0.Output
              }], onSelectedDateChanged: [{
                  type: i0.Output
              }], focusDateChange: [{
                  type: i0.Output
              }], selectedDateChange: [{
                  type: i0.Output
              }] } });

  var GcComboBoxColumnComponent = /** @class */ (function () {
      function GcComboBoxColumnComponent() {
      }
      return GcComboBoxColumnComponent;
  }());
  GcComboBoxColumnComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcComboBoxColumnComponent, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
  GcComboBoxColumnComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.17", type: GcComboBoxColumnComponent, selector: "gc-combo-box-column", inputs: { name: "name", label: "label", width: "width", isValuePath: "isValuePath", visible: "visible", clickSort: "clickSort", contentAlignment: "contentAlignment", headerAlignment: "headerAlignment", showTip: "showTip" }, ngImport: i0__namespace, template: "", isInline: true });
  i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcComboBoxColumnComponent, decorators: [{
              type: i0.Component,
              args: [{
                      selector: 'gc-combo-box-column',
                      template: ""
                  }]
          }], propDecorators: { name: [{
                  type: i0.Input
              }], label: [{
                  type: i0.Input
              }], width: [{
                  type: i0.Input
              }], isValuePath: [{
                  type: i0.Input
              }], visible: [{
                  type: i0.Input
              }], clickSort: [{
                  type: i0.Input
              }], contentAlignment: [{
                  type: i0.Input
              }], headerAlignment: [{
                  type: i0.Input
              }], showTip: [{
                  type: i0.Input
              }] } });
  var GcComboBoxComponent = /** @class */ (function (_super) {
      __extends(GcComboBoxComponent, _super);
      function GcComboBoxComponent(ref) {
          var _this = _super.call(this, ref) || this;
          _this.selectedChanged = new i0.EventEmitter();
          _this.checkedChanged = new i0.EventEmitter();
          _this.dropDownClosed = new i0.EventEmitter();
          _this.dropDownOpened = new i0.EventEmitter();
          _this.textChanged = new i0.EventEmitter();
          _this.spinDown = new i0.EventEmitter();
          _this.spinUp = new i0.EventEmitter();
          _this.itemsChanged = new i0.EventEmitter();
          _this.itemsChange = new i0.EventEmitter();
          _this.selectedValueChange = new i0.EventEmitter();
          _this.selectedIndexChange = new i0.EventEmitter();
          _this.checkedValuesChange = new i0.EventEmitter();
          _this.selectedItemChange = new i0.EventEmitter();
          _this.checkedItemsChange = new i0.EventEmitter();
          _this.checkedIndicesChange = new i0.EventEmitter();
          return _this;
      }
      GcComboBoxComponent.prototype.writeValue = function (value) {
          this.text = value;
          if (this._imCtrl) {
              this._imCtrl.text = this.text;
          }
      };
      GcComboBoxComponent.prototype.registerOnChange = function (onChange) {
          this.onChange = onChange;
      };
      GcComboBoxComponent.prototype.registerOnTouched = function (onTouched) {
          this.onTouched = onTouched;
      };
      GcComboBoxComponent.prototype.setDisabledState = function (isDisabled) {
          this._imCtrl.enabled = !isDisabled;
      };
      GcComboBoxComponent.prototype.initGcComponent = function () {
          var _this = this;
          if (this.columnComponents && this.columnComponents.length > 0) {
              this.columns = [];
              this.columnComponents.forEach(function (column) {
                  _this.columns.push({
                      name: column.name,
                      label: column.label,
                      width: column.width,
                      isValuePath: column.isValuePath,
                      visible: column.visible,
                      clickSort: column.clickSort,
                      contentAlignment: column.contentAlignment,
                      headerAlignment: column.headerAlignment,
                      showTip: column.showTip
                  });
              });
          }
          var element = document.createElement('select');
          this.createTemplate(element);
          this._imCtrl = new GC__namespace.InputMan.GcComboBox(element, this);
      };
      GcComboBoxComponent.prototype.bindEvent = function () {
          var _this = this;
          if (!this._imCtrl) {
              return;
          }
          this._imCtrl.addEventListener(GC__namespace.InputMan.GcComboBoxEvent.SelectedChanged, function (eventArgs) {
              _this.selectedChanged.emit(eventArgs);
              _this.selectedValueChange.emit(_this._imCtrl.getSelectedValue());
              _this.selectedIndexChange.emit(_this._imCtrl.getSelectedIndex());
              _this.selectedItemChange.emit(_this._imCtrl.getSelectedItem());
          });
          this._imCtrl.addEventListener(GC__namespace.InputMan.GcComboBoxEvent.CheckedChanged, function (eventArgs) {
              _this.checkedChanged.emit(eventArgs);
              _this.checkedValuesChange.emit(_this._imCtrl.getCheckedValues());
              _this.checkedItemsChange.emit(_this._imCtrl.getCheckedItems());
              _this.checkedIndicesChange.emit(_this._imCtrl.getCheckedIndices());
          });
          this._imCtrl.addEventListener(GC__namespace.InputMan.GcComboBoxEvent.DropDownClosed, function (eventArgs) {
              _this.dropDownClosed.emit(eventArgs);
          });
          this._imCtrl.addEventListener(GC__namespace.InputMan.GcComboBoxEvent.DropDownOpened, function (eventArgs) {
              _this.dropDownOpened.emit(eventArgs);
          });
          this._imCtrl.addEventListener(GC__namespace.InputMan.GcComboBoxEvent.TextChanged, function (eventArgs) {
              _this.textChanged.emit(eventArgs);
              _this.onChange(_this._imCtrl.text);
              _this.onTouched();
          });
          this._imCtrl.addEventListener(GC__namespace.InputMan.GcComboBoxEvent.SpinDown, function (eventArgs) {
              _this.spinDown.emit(eventArgs);
          });
          this._imCtrl.addEventListener(GC__namespace.InputMan.GcComboBoxEvent.SpinUp, function (eventArgs) {
              _this.spinUp.emit(eventArgs);
          });
          this._imCtrl.addEventListener(GC__namespace.InputMan.GcComboBoxEvent.ItemsChanged, function (eventArgs) {
              _this.itemsChanged.emit(eventArgs);
              _this.itemsChange.emit(_this._imCtrl.getItems());
          });
      };
      return GcComboBoxComponent;
  }(GcComponents));
  GcComboBoxComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcComboBoxComponent, deps: [{ token: i0__namespace.ElementRef }], target: i0__namespace.ɵɵFactoryTarget.Component });
  GcComboBoxComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.17", type: GcComboBoxComponent, selector: "gc-combo-box", inputs: { items: "items", selectedValue: "selectedValue", allowDropDownResize: "allowDropDownResize", readOnly: "readOnly", autoSelect: "autoSelect", selectedIndex: "selectedIndex", autoFilter: "autoFilter", visible: "visible", enabled: "enabled", showTip: "showTip", isEditable: "isEditable", watermarkDisplayNullText: "watermarkDisplayNullText", watermarkNullText: "watermarkNullText", highlightText: "highlightText", exitOnEnterKey: "exitOnEnterKey", useClipboard: "useClipboard", acceptsCrlf: "acceptsCrlf", ellipsis: "ellipsis", ellipsisString: "ellipsisString", exitOnLeftRightKey: "exitOnLeftRightKey", tabIndex: "tabIndex", showHelpButton: "showHelpButton", autoCompleteMode: "autoCompleteMode", autoCompleteMatchMode: "autoCompleteMatchMode", showCopyButton: "showCopyButton", helpContent: "helpContent", copyMessage: "copyMessage", copiedMessage: "copiedMessage", editMode: "editMode", checkedValues: "checkedValues", selectedItem: "selectedItem", checkedItems: "checkedItems", checkedIndices: "checkedIndices", showDropDownButton: "showDropDownButton", dropDownButtonPosition: "dropDownButtonPosition", showSpinButton: "showSpinButton", spinButtonPosition: "spinButtonPosition", dropDownWidth: "dropDownWidth", dropDownHeight: "dropDownHeight", minPrefixLength: "minPrefixLength", isMultiSelect: "isMultiSelect", dropDownOverflow: "dropDownOverflow", visibleItems: "visibleItems", itemHeight: "itemHeight", columns: "columns", showHeader: "showHeader", valueMemberPath: "valueMemberPath", displayMemberPath: "displayMemberPath", checkOnClick: "checkOnClick", itemTemplate: "itemTemplate", headerTemplate: "headerTemplate", footerTemplate: "footerTemplate", spinWheel: "spinWheel", emptyTemplate: "emptyTemplate", load: "load", pageSize: "pageSize", virtualMode: "virtualMode", generatingItem: "generatingItem", selectTemplate: "selectTemplate", formatItem: "formatItem", allowColumnResize: "allowColumnResize", colHeaderHeight: "colHeaderHeight", container: "container", autoDropDown: "autoDropDown", dropDownButtonVisible: "dropDownButtonVisible", showClearButton: "showClearButton", autoScale: "autoScale", minScaleFactor: "minScaleFactor", multipleItemSeparator: "multipleItemSeparator" }, outputs: { selectedChanged: "selectedChanged", checkedChanged: "checkedChanged", dropDownClosed: "dropDownClosed", dropDownOpened: "dropDownOpened", textChanged: "textChanged", spinDown: "spinDown", spinUp: "spinUp", itemsChanged: "itemsChanged", itemsChange: "itemsChange", selectedValueChange: "selectedValueChange", selectedIndexChange: "selectedIndexChange", checkedValuesChange: "checkedValuesChange", selectedItemChange: "selectedItemChange", checkedItemsChange: "checkedItemsChange", checkedIndicesChange: "checkedIndicesChange" }, providers: [
          provideParent(GcComboBoxComponent),
          {
              provide: forms.NG_VALUE_ACCESSOR,
              multi: true,
              useExisting: i0.forwardRef(function () { return GcComboBoxComponent; }),
          }
      ], queries: [{ propertyName: "columnComponents", predicate: GcComboBoxColumnComponent }], usesInheritance: true, ngImport: i0__namespace, template: "", isInline: true });
  __decorate([
      Property("", "", false, false),
      __metadata("design:type", Object)
  ], GcComboBoxComponent.prototype, "selectedValue", void 0);
  __decorate([
      Property("", "", false, false),
      __metadata("design:type", Number)
  ], GcComboBoxComponent.prototype, "selectedIndex", void 0);
  __decorate([
      Property("setEditable"),
      __metadata("design:type", Boolean)
  ], GcComboBoxComponent.prototype, "isEditable", void 0);
  __decorate([
      Property("", "", false, false),
      __metadata("design:type", Object)
  ], GcComboBoxComponent.prototype, "checkedValues", void 0);
  __decorate([
      Property("", "", false, false),
      __metadata("design:type", Object)
  ], GcComboBoxComponent.prototype, "selectedItem", void 0);
  __decorate([
      Property("", "", false, false),
      __metadata("design:type", Object)
  ], GcComboBoxComponent.prototype, "checkedItems", void 0);
  __decorate([
      Property("", "", false, false),
      __metadata("design:type", Array)
  ], GcComboBoxComponent.prototype, "checkedIndices", void 0);
  i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcComboBoxComponent, decorators: [{
              type: i0.Component,
              args: [{
                      selector: 'gc-combo-box',
                      template: "",
                      providers: [
                          provideParent(GcComboBoxComponent),
                          {
                              provide: forms.NG_VALUE_ACCESSOR,
                              multi: true,
                              useExisting: i0.forwardRef(function () { return GcComboBoxComponent; }),
                          }
                      ]
                  }]
          }], ctorParameters: function () { return [{ type: i0__namespace.ElementRef }]; }, propDecorators: { items: [{
                  type: i0.Input
              }], selectedValue: [{
                  type: i0.Input
              }], allowDropDownResize: [{
                  type: i0.Input
              }], readOnly: [{
                  type: i0.Input
              }], autoSelect: [{
                  type: i0.Input
              }], selectedIndex: [{
                  type: i0.Input
              }], autoFilter: [{
                  type: i0.Input
              }], visible: [{
                  type: i0.Input
              }], enabled: [{
                  type: i0.Input
              }], showTip: [{
                  type: i0.Input
              }], isEditable: [{
                  type: i0.Input
              }], watermarkDisplayNullText: [{
                  type: i0.Input
              }], watermarkNullText: [{
                  type: i0.Input
              }], highlightText: [{
                  type: i0.Input
              }], exitOnEnterKey: [{
                  type: i0.Input
              }], useClipboard: [{
                  type: i0.Input
              }], acceptsCrlf: [{
                  type: i0.Input
              }], ellipsis: [{
                  type: i0.Input
              }], ellipsisString: [{
                  type: i0.Input
              }], exitOnLeftRightKey: [{
                  type: i0.Input
              }], tabIndex: [{
                  type: i0.Input
              }], showHelpButton: [{
                  type: i0.Input
              }], autoCompleteMode: [{
                  type: i0.Input
              }], autoCompleteMatchMode: [{
                  type: i0.Input
              }], showCopyButton: [{
                  type: i0.Input
              }], helpContent: [{
                  type: i0.Input
              }], copyMessage: [{
                  type: i0.Input
              }], copiedMessage: [{
                  type: i0.Input
              }], editMode: [{
                  type: i0.Input
              }], checkedValues: [{
                  type: i0.Input
              }], selectedItem: [{
                  type: i0.Input
              }], checkedItems: [{
                  type: i0.Input
              }], checkedIndices: [{
                  type: i0.Input
              }], showDropDownButton: [{
                  type: i0.Input
              }], dropDownButtonPosition: [{
                  type: i0.Input
              }], showSpinButton: [{
                  type: i0.Input
              }], spinButtonPosition: [{
                  type: i0.Input
              }], dropDownWidth: [{
                  type: i0.Input
              }], dropDownHeight: [{
                  type: i0.Input
              }], minPrefixLength: [{
                  type: i0.Input
              }], isMultiSelect: [{
                  type: i0.Input
              }], dropDownOverflow: [{
                  type: i0.Input
              }], visibleItems: [{
                  type: i0.Input
              }], itemHeight: [{
                  type: i0.Input
              }], columns: [{
                  type: i0.Input
              }], showHeader: [{
                  type: i0.Input
              }], valueMemberPath: [{
                  type: i0.Input
              }], displayMemberPath: [{
                  type: i0.Input
              }], checkOnClick: [{
                  type: i0.Input
              }], itemTemplate: [{
                  type: i0.Input
              }], headerTemplate: [{
                  type: i0.Input
              }], footerTemplate: [{
                  type: i0.Input
              }], spinWheel: [{
                  type: i0.Input
              }], emptyTemplate: [{
                  type: i0.Input
              }], load: [{
                  type: i0.Input
              }], pageSize: [{
                  type: i0.Input
              }], virtualMode: [{
                  type: i0.Input
              }], generatingItem: [{
                  type: i0.Input
              }], selectTemplate: [{
                  type: i0.Input
              }], formatItem: [{
                  type: i0.Input
              }], allowColumnResize: [{
                  type: i0.Input
              }], colHeaderHeight: [{
                  type: i0.Input
              }], container: [{
                  type: i0.Input
              }], autoDropDown: [{
                  type: i0.Input
              }], dropDownButtonVisible: [{
                  type: i0.Input
              }], showClearButton: [{
                  type: i0.Input
              }], autoScale: [{
                  type: i0.Input
              }], minScaleFactor: [{
                  type: i0.Input
              }], multipleItemSeparator: [{
                  type: i0.Input
              }], selectedChanged: [{
                  type: i0.Output
              }], checkedChanged: [{
                  type: i0.Output
              }], dropDownClosed: [{
                  type: i0.Output
              }], dropDownOpened: [{
                  type: i0.Output
              }], textChanged: [{
                  type: i0.Output
              }], spinDown: [{
                  type: i0.Output
              }], spinUp: [{
                  type: i0.Output
              }], itemsChanged: [{
                  type: i0.Output
              }], itemsChange: [{
                  type: i0.Output
              }], selectedValueChange: [{
                  type: i0.Output
              }], selectedIndexChange: [{
                  type: i0.Output
              }], checkedValuesChange: [{
                  type: i0.Output
              }], selectedItemChange: [{
                  type: i0.Output
              }], checkedItemsChange: [{
                  type: i0.Output
              }], checkedIndicesChange: [{
                  type: i0.Output
              }], columnComponents: [{
                  type: i0.ContentChildren,
                  args: [GcComboBoxColumnComponent]
              }] } });

  var GcInputManBaseComponent = /** @class */ (function (_super) {
      __extends(GcInputManBaseComponent, _super);
      function GcInputManBaseComponent(ref) {
          var _this = _super.call(this, ref) || this;
          _this.onEditStatusChanged = new i0.EventEmitter();
          _this.onInvalidInput = new i0.EventEmitter();
          _this.onKeyExit = new i0.EventEmitter();
          _this.onTextChanged = new i0.EventEmitter();
          _this.onInput = new i0.EventEmitter();
          _this.onFocusOut = new i0.EventEmitter();
          _this.onKeyDown = new i0.EventEmitter();
          _this.onKeyUp = new i0.EventEmitter();
          _this.onSyncValueToOriginalInput = new i0.EventEmitter();
          // For V2.1 Compatibility, we have to keep this property or event
          _this.textChange = new i0.EventEmitter();
          return _this;
      }
      GcInputManBaseComponent.prototype.bindEvent = function () {
          var _this = this;
          if (!this._imCtrl) {
              return;
          }
          this._imCtrl.onEditStatusChanged(function (s) { _this.onEditStatusChanged.emit(s); });
          this._imCtrl.onInvalidInput(function (s) { _this.onInvalidInput.emit(s); });
          this._imCtrl.onKeyExit(function (s) { _this.onKeyExit.emit(s); });
          this._imCtrl.onTextChanged(function (s) { _this.onTextChanged.emit(s); _this.textChange.emit(s.getText()); });
          this._imCtrl.onInput(function (s) { _this.onInput.emit(s); });
          this._imCtrl.onFocusOut(function (s) { _this.onFocusOut.emit({ sender: s }); });
          this._imCtrl.onKeyDown(function (s) { _this.onKeyDown.emit({ sender: s }); });
          this._imCtrl.onKeyUp(function (s) { _this.onKeyUp.emit({ sender: s }); });
          this._imCtrl.onSyncValueToOriginalInput(function (v, e) { _this.onSyncValueToOriginalInput.emit({ value: v, element: e }); });
      };
      return GcInputManBaseComponent;
  }(GcComponents));
  GcInputManBaseComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcInputManBaseComponent, deps: [{ token: i0__namespace.ElementRef }], target: i0__namespace.ɵɵFactoryTarget.Component });
  GcInputManBaseComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.17", type: GcInputManBaseComponent, selector: "ng-component", inputs: { visible: "visible", enabled: "enabled", readOnly: "readOnly", exitOnLeftRightKey: "exitOnLeftRightKey", editMode: "editMode", watermarkDisplayNullText: "watermarkDisplayNullText", watermarkNullText: "watermarkNullText", acceptsCrlf: "acceptsCrlf", useClipboard: "useClipboard", exitOnEnterKey: "exitOnEnterKey", container: "container", autoDropDown: "autoDropDown", dropDownButtonVisible: "dropDownButtonVisible", autoScale: "autoScale", minScaleFactor: "minScaleFactor", tabIndex: "tabIndex", showHelpButton: "showHelpButton", showCopyButton: "showCopyButton", helpContent: "helpContent", copyMessage: "copyMessage", copiedMessage: "copiedMessage" }, outputs: { onEditStatusChanged: "onEditStatusChanged", onInvalidInput: "onInvalidInput", onKeyExit: "onKeyExit", onTextChanged: "onTextChanged", onInput: "onInput", onFocusOut: "onFocusOut", onKeyDown: "onKeyDown", onKeyUp: "onKeyUp", onSyncValueToOriginalInput: "onSyncValueToOriginalInput", textChange: "textChange" }, usesInheritance: true, ngImport: i0__namespace, template: '', isInline: true });
  i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcInputManBaseComponent, decorators: [{
              type: i0.Component,
              args: [{
                      template: ''
                  }]
          }], ctorParameters: function () { return [{ type: i0__namespace.ElementRef }]; }, propDecorators: { visible: [{
                  type: i0.Input
              }], enabled: [{
                  type: i0.Input
              }], readOnly: [{
                  type: i0.Input
              }], exitOnLeftRightKey: [{
                  type: i0.Input
              }], editMode: [{
                  type: i0.Input
              }], watermarkDisplayNullText: [{
                  type: i0.Input
              }], watermarkNullText: [{
                  type: i0.Input
              }], acceptsCrlf: [{
                  type: i0.Input
              }], useClipboard: [{
                  type: i0.Input
              }], exitOnEnterKey: [{
                  type: i0.Input
              }], container: [{
                  type: i0.Input
              }], autoDropDown: [{
                  type: i0.Input
              }], dropDownButtonVisible: [{
                  type: i0.Input
              }], autoScale: [{
                  type: i0.Input
              }], minScaleFactor: [{
                  type: i0.Input
              }], tabIndex: [{
                  type: i0.Input
              }], showHelpButton: [{
                  type: i0.Input
              }], showCopyButton: [{
                  type: i0.Input
              }], helpContent: [{
                  type: i0.Input
              }], copyMessage: [{
                  type: i0.Input
              }], copiedMessage: [{
                  type: i0.Input
              }], onEditStatusChanged: [{
                  type: i0.Output
              }], onInvalidInput: [{
                  type: i0.Output
              }], onKeyExit: [{
                  type: i0.Output
              }], onTextChanged: [{
                  type: i0.Output
              }], onInput: [{
                  type: i0.Output
              }], onFocusOut: [{
                  type: i0.Output
              }], onKeyDown: [{
                  type: i0.Output
              }], onKeyUp: [{
                  type: i0.Output
              }], onSyncValueToOriginalInput: [{
                  type: i0.Output
              }], textChange: [{
                  type: i0.Output
              }] } });

  var GcDateTimeComponent = /** @class */ (function (_super) {
      __extends(GcDateTimeComponent, _super);
      function GcDateTimeComponent(ref) {
          var _this = _super.call(this, ref) || this;
          _this.onSpinDown = new i0.EventEmitter();
          _this.onSpinUp = new i0.EventEmitter();
          _this.onInvalidRange = new i0.EventEmitter();
          _this.onInvalidValue = new i0.EventEmitter();
          _this.onNumberChanged = new i0.EventEmitter();
          _this.onValueChanged = new i0.EventEmitter();
          // For V2.1 Compatibility, we have to keep this property or event
          _this.numberChange = new i0.EventEmitter();
          _this.valueChange = new i0.EventEmitter();
          return _this;
      }
      GcDateTimeComponent.prototype.writeValue = function (value) {
          this.value = value;
          if (this._imCtrl) {
              this._imCtrl.value = this.value;
          }
      };
      GcDateTimeComponent.prototype.registerOnChange = function (onChange) {
          this.onChange = onChange;
      };
      GcDateTimeComponent.prototype.registerOnTouched = function (onTouched) {
          this.onTouched = onTouched;
      };
      GcDateTimeComponent.prototype.setDisabledState = function (isDisabled) {
          this._imCtrl.enabled = !isDisabled;
      };
      GcDateTimeComponent.prototype.initGcComponent = function () {
          var element = document.createElement('input');
          this.createTemplate(element);
          this._imCtrl = new GC__namespace.InputMan.GcDateTime(element, this);
      };
      GcDateTimeComponent.prototype.bindEvent = function () {
          var _this = this;
          if (!this._imCtrl) {
              return;
          }
          _super.prototype.bindEvent.call(this);
          this._imCtrl.onSpinDown(function (s) { _this.onSpinDown.emit(s); });
          this._imCtrl.onSpinUp(function (s) { _this.onSpinUp.emit(s); });
          this._imCtrl.onInvalidRange(function (s) { _this.onInvalidRange.emit(s); });
          this._imCtrl.onInvalidValue(function (s) { _this.onInvalidValue.emit(s); });
          this._imCtrl.onNumberChanged(function (s) {
              _this.onNumberChanged.emit(s);
              _this.numberChange.emit(s.getNumber());
          });
          this._imCtrl.onValueChanged(function (s) {
              _this.onValueChanged.emit(s);
              _this.onChange(s.getValue());
              _this.onTouched();
              _this.valueChange.emit(s.getValue());
          });
      };
      return GcDateTimeComponent;
  }(GcInputManBaseComponent));
  GcDateTimeComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcDateTimeComponent, deps: [{ token: i0__namespace.ElementRef }], target: i0__namespace.ɵɵFactoryTarget.Component });
  GcDateTimeComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.17", type: GcDateTimeComponent, selector: "gc-datetime", inputs: { text: "text", number: "number", maxDate: "maxDate", minDate: "minDate", formatPattern: "formatPattern", spinIncrement: "spinIncrement", spinOnKeys: "spinOnKeys", spinWrap: "spinWrap", allowSpin: "allowSpin", spinWheel: "spinWheel", displayFormatPattern: "displayFormatPattern", watermarkEmptyEraText: "watermarkEmptyEraText", promptChar: "promptChar", AMDesignator: "AMDesignator", PMDesignator: "PMDesignator", twoDigitYearMax: "twoDigitYearMax", hour12Mode: "hour12Mode", tabAction: "tabAction", maxMinBehavior: "maxMinBehavior", midnightAs24: "midnightAs24", showLiterals: "showLiterals", adjustValueOnFocus: "adjustValueOnFocus", useTwoDigitYearMax: "useTwoDigitYearMax", validateMode: "validateMode", clipContent: "clipContent", value: "value", watermarkDisplayEmptyEraText: "watermarkDisplayEmptyEraText", dropDownConfig: "dropDownConfig", exitOnLastChar: "exitOnLastChar", highlightText: "highlightText", showSpinButton: "showSpinButton", spinButtonPosition: "spinButtonPosition", showDropDownButton: "showDropDownButton", dropDownButtonAlignment: "dropDownButtonAlignment", showClearButton: "showClearButton" }, outputs: { onSpinDown: "onSpinDown", onSpinUp: "onSpinUp", onInvalidRange: "onInvalidRange", onInvalidValue: "onInvalidValue", onNumberChanged: "onNumberChanged", onValueChanged: "onValueChanged", numberChange: "numberChange", valueChange: "valueChange" }, providers: [
          provideParent(GcDateTimeComponent),
          {
              provide: forms.NG_VALUE_ACCESSOR,
              multi: true,
              useExisting: i0.forwardRef(function () { return GcDateTimeComponent; }),
          }
      ], usesInheritance: true, ngImport: i0__namespace, template: "", isInline: true });
  __decorate([
      Property("", "", false, false),
      __metadata("design:type", Number)
  ], GcDateTimeComponent.prototype, "number", void 0);
  i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcDateTimeComponent, decorators: [{
              type: i0.Component,
              args: [{
                      selector: 'gc-datetime',
                      template: "",
                      providers: [
                          provideParent(GcDateTimeComponent),
                          {
                              provide: forms.NG_VALUE_ACCESSOR,
                              multi: true,
                              useExisting: i0.forwardRef(function () { return GcDateTimeComponent; }),
                          }
                      ]
                  }]
          }], ctorParameters: function () { return [{ type: i0__namespace.ElementRef }]; }, propDecorators: { text: [{
                  type: i0.Input
              }], number: [{
                  type: i0.Input
              }], maxDate: [{
                  type: i0.Input
              }], minDate: [{
                  type: i0.Input
              }], formatPattern: [{
                  type: i0.Input
              }], spinIncrement: [{
                  type: i0.Input
              }], spinOnKeys: [{
                  type: i0.Input
              }], spinWrap: [{
                  type: i0.Input
              }], allowSpin: [{
                  type: i0.Input
              }], spinWheel: [{
                  type: i0.Input
              }], displayFormatPattern: [{
                  type: i0.Input
              }], watermarkEmptyEraText: [{
                  type: i0.Input
              }], promptChar: [{
                  type: i0.Input
              }], AMDesignator: [{
                  type: i0.Input
              }], PMDesignator: [{
                  type: i0.Input
              }], twoDigitYearMax: [{
                  type: i0.Input
              }], hour12Mode: [{
                  type: i0.Input
              }], tabAction: [{
                  type: i0.Input
              }], maxMinBehavior: [{
                  type: i0.Input
              }], midnightAs24: [{
                  type: i0.Input
              }], showLiterals: [{
                  type: i0.Input
              }], adjustValueOnFocus: [{
                  type: i0.Input
              }], useTwoDigitYearMax: [{
                  type: i0.Input
              }], validateMode: [{
                  type: i0.Input
              }], clipContent: [{
                  type: i0.Input
              }], value: [{
                  type: i0.Input
              }], watermarkDisplayEmptyEraText: [{
                  type: i0.Input
              }], dropDownConfig: [{
                  type: i0.Input
              }], exitOnLastChar: [{
                  type: i0.Input
              }], highlightText: [{
                  type: i0.Input
              }], showSpinButton: [{
                  type: i0.Input
              }], spinButtonPosition: [{
                  type: i0.Input
              }], showDropDownButton: [{
                  type: i0.Input
              }], dropDownButtonAlignment: [{
                  type: i0.Input
              }], showClearButton: [{
                  type: i0.Input
              }], onSpinDown: [{
                  type: i0.Output
              }], onSpinUp: [{
                  type: i0.Output
              }], onInvalidRange: [{
                  type: i0.Output
              }], onInvalidValue: [{
                  type: i0.Output
              }], onNumberChanged: [{
                  type: i0.Output
              }], onValueChanged: [{
                  type: i0.Output
              }], numberChange: [{
                  type: i0.Output
              }], valueChange: [{
                  type: i0.Output
              }] } });

  var GcDateTimePickerComponent = /** @class */ (function (_super) {
      __extends(GcDateTimePickerComponent, _super);
      function GcDateTimePickerComponent(ref) {
          var _this = _super.call(this, ref) || this;
          _this.selectedDateChanged = new i0.EventEmitter();
          _this.selectedValueChange = new i0.EventEmitter();
          return _this;
      }
      GcDateTimePickerComponent.prototype.writeValue = function (value) {
          this.selectedValue = value;
          if (this._imCtrl) {
              this._imCtrl.value = this.selectedValue;
          }
      };
      GcDateTimePickerComponent.prototype.registerOnChange = function (onChange) {
          this.onChange = onChange;
      };
      GcDateTimePickerComponent.prototype.registerOnTouched = function (onTouched) {
          this.onTouched = onTouched;
      };
      GcDateTimePickerComponent.prototype.setDisabledState = function (isDisabled) {
          this._imCtrl.enabled = !isDisabled;
      };
      GcDateTimePickerComponent.prototype.initGcComponent = function () {
          var element = document.createElement('div');
          this.createTemplate(element);
          this._imCtrl = new GC__namespace.InputMan.GcDateTimePicker(element, this);
      };
      GcDateTimePickerComponent.prototype.bindEvent = function () {
          var _this = this;
          if (!this._imCtrl) {
              return;
          }
          this._imCtrl.addEventListener(GC__namespace.InputMan.GcDateTimePickerEvent.SelectedDateChanged, function (sender, eventArgs) {
              _this.selectedDateChanged.emit({ sender: sender, eArgs: eventArgs });
              _this.selectedValueChange.emit(_this._imCtrl.getValue());
              _this.onChange(_this._imCtrl.getValue());
              _this.onTouched();
          });
      };
      return GcDateTimePickerComponent;
  }(GcComponents));
  GcDateTimePickerComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcDateTimePickerComponent, deps: [{ token: i0__namespace.ElementRef }], target: i0__namespace.ɵɵFactoryTarget.Component });
  GcDateTimePickerComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.17", type: GcDateTimePickerComponent, selector: "gc-datetime-picker", inputs: { selectedValue: "selectedValue", maxDate: "maxDate", minDate: "minDate", type: "type", minuteInterval: "minuteInterval", secondsInterval: "secondsInterval", visible: "visible", hasSeconds: "hasSeconds", showMidnightAs24: "showMidnightAs24", yearFormat: "yearFormat", monthFormat: "monthFormat", dayFormat: "dayFormat" }, outputs: { selectedDateChanged: "selectedDateChanged", selectedValueChange: "selectedValueChange" }, providers: [
          {
              provide: forms.NG_VALUE_ACCESSOR,
              multi: true,
              useExisting: i0.forwardRef(function () { return GcDateTimePickerComponent; }),
          }
      ], usesInheritance: true, ngImport: i0__namespace, template: "", isInline: true });
  __decorate([
      Property("setValue"),
      __metadata("design:type", Date)
  ], GcDateTimePickerComponent.prototype, "selectedValue", void 0);
  __decorate([
      Property('setPickerType'),
      __metadata("design:type", String)
  ], GcDateTimePickerComponent.prototype, "type", void 0);
  __decorate([
      Property('showSeconds', "", false, false),
      __metadata("design:type", String)
  ], GcDateTimePickerComponent.prototype, "hasSeconds", void 0);
  __decorate([
      Property('showMidnightAs24', "", false, false),
      __metadata("design:type", String)
  ], GcDateTimePickerComponent.prototype, "showMidnightAs24", void 0);
  i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcDateTimePickerComponent, decorators: [{
              type: i0.Component,
              args: [{
                      selector: 'gc-datetime-picker',
                      template: "",
                      providers: [
                          {
                              provide: forms.NG_VALUE_ACCESSOR,
                              multi: true,
                              useExisting: i0.forwardRef(function () { return GcDateTimePickerComponent; }),
                          }
                      ]
                  }]
          }], ctorParameters: function () { return [{ type: i0__namespace.ElementRef }]; }, propDecorators: { selectedValue: [{
                  type: i0.Input
              }], maxDate: [{
                  type: i0.Input
              }], minDate: [{
                  type: i0.Input
              }], type: [{
                  type: i0.Input
              }], minuteInterval: [{
                  type: i0.Input
              }], secondsInterval: [{
                  type: i0.Input
              }], visible: [{
                  type: i0.Input
              }], hasSeconds: [{
                  type: i0.Input
              }], showMidnightAs24: [{
                  type: i0.Input
              }], yearFormat: [{
                  type: i0.Input
              }], monthFormat: [{
                  type: i0.Input
              }], dayFormat: [{
                  type: i0.Input
              }], selectedDateChanged: [{
                  type: i0.Output
              }], selectedValueChange: [{
                  type: i0.Output
              }] } });

  var GcFormPersistenceComponent = /** @class */ (function (_super) {
      __extends(GcFormPersistenceComponent, _super);
      function GcFormPersistenceComponent(ref) {
          return _super.call(this, ref) || this;
      }
      GcFormPersistenceComponent.prototype.initGcComponent = function () {
          var form = this._container.querySelector('form');
          if (form) {
              this._imCtrl = new GC__namespace.InputMan.GcFormPersistence(form, this);
              this._imCtrl.persist();
          }
      };
      GcFormPersistenceComponent.prototype.bindEvent = function () { };
      return GcFormPersistenceComponent;
  }(GcComponents));
  GcFormPersistenceComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcFormPersistenceComponent, deps: [{ token: i0__namespace.ElementRef }], target: i0__namespace.ɵɵFactoryTarget.Component });
  GcFormPersistenceComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.17", type: GcFormPersistenceComponent, selector: "gc-form-persistence", inputs: { id: "id", storageMode: "storageMode", saveMode: "saveMode" }, providers: [provideParent(GcFormPersistenceComponent)], usesInheritance: true, ngImport: i0__namespace, template: "<ng-content></ng-content>", isInline: true });
  i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcFormPersistenceComponent, decorators: [{
              type: i0.Component,
              args: [{
                      selector: 'gc-form-persistence',
                      template: "<ng-content></ng-content>",
                      providers: [provideParent(GcFormPersistenceComponent)]
                  }]
          }], ctorParameters: function () { return [{ type: i0__namespace.ElementRef }]; }, propDecorators: { id: [{
                  type: i0.Input
              }], storageMode: [{
                  type: i0.Input
              }], saveMode: [{
                  type: i0.Input
              }] } });

  var GcFunctionKeyInfoComponent = /** @class */ (function () {
      function GcFunctionKeyInfoComponent() {
      }
      return GcFunctionKeyInfoComponent;
  }());
  GcFunctionKeyInfoComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcFunctionKeyInfoComponent, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
  GcFunctionKeyInfoComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.17", type: GcFunctionKeyInfoComponent, selector: "gc-function-key-info", inputs: { key: "key", description: "description", tipText: "tipText", displayStyle: "displayStyle", imagePosition: "imagePosition" }, ngImport: i0__namespace, template: "", isInline: true });
  i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcFunctionKeyInfoComponent, decorators: [{
              type: i0.Component,
              args: [{
                      selector: 'gc-function-key-info',
                      template: ""
                  }]
          }], propDecorators: { key: [{
                  type: i0.Input
              }], description: [{
                  type: i0.Input
              }], tipText: [{
                  type: i0.Input
              }], displayStyle: [{
                  type: i0.Input
              }], imagePosition: [{
                  type: i0.Input
              }] } });
  var GcFunctionKeyComponent = /** @class */ (function (_super) {
      __extends(GcFunctionKeyComponent, _super);
      function GcFunctionKeyComponent(ref) {
          var _this = _super.call(this, ref) || this;
          _this.onActived = new i0.EventEmitter();
          return _this;
      }
      GcFunctionKeyComponent.prototype.initGcComponent = function () {
          var _this = this;
          if (this.functionKeyComponents && this.functionKeyComponents.length > 0) {
              this.functionKeys = [];
              this.functionKeyComponents.forEach(function (functionKeyInfo) {
                  _this.functionKeys.push({
                      key: functionKeyInfo.key,
                      description: functionKeyInfo.description,
                      tipText: functionKeyInfo.tipText,
                      displayStyle: functionKeyInfo.displayStyle,
                      imagePosition: functionKeyInfo.imagePosition
                  });
              });
          }
          var element = document.createElement('div');
          this.createTemplate(element);
          this._imCtrl = new GC__namespace.InputMan.GcFunctionKey(element, this);
      };
      GcFunctionKeyComponent.prototype.bindEvent = function () {
          var _this = this;
          if (!this._imCtrl)
              return;
          this._imCtrl.onActived(function (s, e) {
              _this.onActived.emit(e);
          });
      };
      return GcFunctionKeyComponent;
  }(GcComponents));
  GcFunctionKeyComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcFunctionKeyComponent, deps: [{ token: i0__namespace.ElementRef }], target: i0__namespace.ɵɵFactoryTarget.Component });
  GcFunctionKeyComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.17", type: GcFunctionKeyComponent, selector: "gc-function-key", inputs: { keyRepeat: "keyRepeat", handleMouse: "handleMouse", showTip: "showTip", combinationKeyDisplayMode: "combinationKeyDisplayMode", functionKeys: "functionKeys", enabled: "enabled", visible: "visible" }, outputs: { onActived: "onActived" }, queries: [{ propertyName: "functionKeyComponents", predicate: GcFunctionKeyInfoComponent }], usesInheritance: true, ngImport: i0__namespace, template: "", isInline: true });
  __decorate([
      Property("addFunctionKey", "", true),
      __metadata("design:type", Array)
  ], GcFunctionKeyComponent.prototype, "functionKeys", void 0);
  i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcFunctionKeyComponent, decorators: [{
              type: i0.Component,
              args: [{
                      selector: 'gc-function-key',
                      template: ""
                  }]
          }], ctorParameters: function () { return [{ type: i0__namespace.ElementRef }]; }, propDecorators: { keyRepeat: [{
                  type: i0.Input
              }], handleMouse: [{
                  type: i0.Input
              }], showTip: [{
                  type: i0.Input
              }], combinationKeyDisplayMode: [{
                  type: i0.Input
              }], functionKeys: [{
                  type: i0.Input
              }], enabled: [{
                  type: i0.Input
              }], visible: [{
                  type: i0.Input
              }], functionKeyComponents: [{
                  type: i0.ContentChildren,
                  args: [GcFunctionKeyInfoComponent]
              }], onActived: [{
                  type: i0.Output
              }] } });

  var GcIconNotifierComponent = /** @class */ (function (_super) {
      __extends(GcIconNotifierComponent, _super);
      function GcIconNotifierComponent(ref, _parent) {
          var _this = _super.call(this, ref) || this;
          _this._parent = _parent;
          return _this;
      }
      GcIconNotifierComponent.prototype.ngAfterViewInit = function () {
          if (!this._parent || typeof this._parent !== 'object' ||
              typeof this._parent.getNestedIMControl() !== 'object') {
              return;
          }
          this._imCtrl = new GC__namespace.InputMan.GcIconNotifier(this._parent.getNestedIMControl(), this);
          this.onInitialized.emit(this._imCtrl);
      };
      GcIconNotifierComponent.prototype.bindEvent = function () { };
      GcIconNotifierComponent.prototype.initGcComponent = function () {
      };
      GcIconNotifierComponent.prototype.onFail = function () {
          return this._imCtrl.onFail();
      };
      GcIconNotifierComponent.prototype.onSuccess = function () {
          return this._imCtrl.onSuccess();
      };
      GcIconNotifierComponent.prototype.onClear = function () {
          return this._imCtrl.onClear();
      };
      return GcIconNotifierComponent;
  }(GcComponents));
  GcIconNotifierComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcIconNotifierComponent, deps: [{ token: i0__namespace.ElementRef }, { token: GcComponents, optional: true }], target: i0__namespace.ɵɵFactoryTarget.Component });
  GcIconNotifierComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.17", type: GcIconNotifierComponent, selector: "gc-icon-notifier", inputs: { direction: "direction", failIcon: "failIcon", successIcon: "successIcon", failMessage: "failMessage", successMessage: "successMessage" }, usesInheritance: true, ngImport: i0__namespace, template: "", isInline: true });
  __decorate([
      Property('setFailIconSrc'),
      __metadata("design:type", String)
  ], GcIconNotifierComponent.prototype, "failIcon", void 0);
  __decorate([
      Property('setSuccessIconSrc'),
      __metadata("design:type", String)
  ], GcIconNotifierComponent.prototype, "successIcon", void 0);
  i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcIconNotifierComponent, decorators: [{
              type: i0.Component,
              args: [{
                      selector: 'gc-icon-notifier',
                      template: "",
                  }]
          }], ctorParameters: function () {
          return [{ type: i0__namespace.ElementRef }, { type: GcComponents, decorators: [{
                          type: i0.Optional
                      }] }];
      }, propDecorators: { direction: [{
                  type: i0.Input
              }], failIcon: [{
                  type: i0.Input
              }], successIcon: [{
                  type: i0.Input
              }], failMessage: [{
                  type: i0.Input
              }], successMessage: [{
                  type: i0.Input
              }] } });

  var GcListBoxColumnComponent = /** @class */ (function () {
      function GcListBoxColumnComponent() {
      }
      return GcListBoxColumnComponent;
  }());
  GcListBoxColumnComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcListBoxColumnComponent, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
  GcListBoxColumnComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.17", type: GcListBoxColumnComponent, selector: "gc-list-box-column", inputs: { name: "name", label: "label", width: "width", isValuePath: "isValuePath", visible: "visible", clickSort: "clickSort", contentAlignment: "contentAlignment", headerAlignment: "headerAlignment", showTip: "showTip" }, ngImport: i0__namespace, template: "", isInline: true });
  i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcListBoxColumnComponent, decorators: [{
              type: i0.Component,
              args: [{
                      selector: 'gc-list-box-column',
                      template: "",
                  }]
          }], propDecorators: { name: [{
                  type: i0.Input
              }], label: [{
                  type: i0.Input
              }], width: [{
                  type: i0.Input
              }], isValuePath: [{
                  type: i0.Input
              }], visible: [{
                  type: i0.Input
              }], clickSort: [{
                  type: i0.Input
              }], contentAlignment: [{
                  type: i0.Input
              }], headerAlignment: [{
                  type: i0.Input
              }], showTip: [{
                  type: i0.Input
              }] } });
  var GcListBoxComponent = /** @class */ (function (_super) {
      __extends(GcListBoxComponent, _super);
      function GcListBoxComponent(ref) {
          var _this = _super.call(this, ref) || this;
          _this.checkedChanged = new i0.EventEmitter();
          _this.selectedChanged = new i0.EventEmitter();
          _this.focusedChanged = new i0.EventEmitter();
          _this.itemClick = new i0.EventEmitter();
          _this.loadComplete = new i0.EventEmitter();
          _this.itemsChanged = new i0.EventEmitter();
          _this.selectedIndexChange = new i0.EventEmitter();
          _this.checkedIndexChange = new i0.EventEmitter();
          _this.selectedIndicesChange = new i0.EventEmitter();
          _this.checkedIndicesChange = new i0.EventEmitter();
          return _this;
      }
      GcListBoxComponent.prototype.initGcComponent = function () {
          var _this = this;
          if (this.columnComponents && this.columnComponents.length > 0) {
              this.columns = [];
              this.columnComponents.forEach(function (column) {
                  _this.columns.push({
                      name: column.name,
                      label: column.label,
                      width: column.width,
                      isValuePath: column.isValuePath,
                      visible: column.visible,
                      clickSort: column.clickSort,
                      contentAlignment: column.contentAlignment,
                      headerAlignment: column.headerAlignment,
                      showTip: column.showTip
                  });
              });
          }
          var element = document.createElement('select');
          this.createTemplate(element);
          this._imCtrl = new GC__namespace.InputMan.GcListBox(element, this);
      };
      GcListBoxComponent.prototype.bindEvent = function () {
          var _this = this;
          if (!this._imCtrl) {
              return;
          }
          this._imCtrl.addEventListener(GC__namespace.InputMan.GcListBoxEvent.CheckedChanged, function (eventArgs) {
              _this.checkedChanged.emit(eventArgs);
              _this.checkedIndexChange.emit(_this._imCtrl.getCheckedIndices()[0]);
              _this.checkedIndicesChange.emit(_this._imCtrl.getCheckedIndices());
          });
          this._imCtrl.addEventListener(GC__namespace.InputMan.GcListBoxEvent.SelectedChanged, function (eventArgs) {
              _this.selectedChanged.emit(eventArgs);
              _this.selectedIndexChange.emit(_this._imCtrl.getSelectedIndex());
              _this.selectedIndicesChange.emit(_this._imCtrl.getSelectedIndices());
          });
          this._imCtrl.addEventListener(GC__namespace.InputMan.GcListBoxEvent.FocusedChanged, function (eventArgs) {
              _this.focusedChanged.emit(eventArgs);
          });
          this._imCtrl.addEventListener(GC__namespace.InputMan.GcListBoxEvent.ItemClick, function (sender, eventArgs) {
              _this.itemClick.emit({ sender: sender, eArgs: eventArgs });
          });
          this._imCtrl.addEventListener(GC__namespace.InputMan.GcListBoxEvent.LoadComplete, function (eventArgs) {
              _this.loadComplete.emit(eventArgs);
          });
          this._imCtrl.addEventListener(GC__namespace.InputMan.GcListBoxEvent.ItemsChanged, function (eventArgs) {
              _this.itemsChanged.emit(eventArgs);
          });
      };
      return GcListBoxComponent;
  }(GcComponents));
  GcListBoxComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcListBoxComponent, deps: [{ token: i0__namespace.ElementRef }], target: i0__namespace.ɵɵFactoryTarget.Component });
  GcListBoxComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.17", type: GcListBoxComponent, selector: "gc-list-box", inputs: { items: "items", columns: "columns", virtualMode: "virtualMode", allowResize: "allowResize", selectionMode: "selectionMode", selectedIndex: "selectedIndex", checkedIndex: "checkedIndex", selectedIndices: "selectedIndices", checkedIndices: "checkedIndices", allowColumnResize: "allowColumnResize", overflow: "overflow", width: "width", height: "height", itemHeight: "itemHeight", checkOnClick: "checkOnClick", visibleItems: "visibleItems", visible: "visible", enabled: "enabled", showTip: "showTip", multiColumn: "multiColumn", colHeaderHeight: "colHeaderHeight", showHeader: "showHeader", valueMemberPath: "valueMemberPath", displayMemberPath: "displayMemberPath", showCheckBox: "showCheckBox", itemTemplate: "itemTemplate", headerTemplate: "headerTemplate", footerTemplate: "footerTemplate", emptyTemplate: "emptyTemplate", load: "load", pageSize: "pageSize", generatingItem: "generatingItem", selectTemplate: "selectTemplate", formatItem: "formatItem" }, outputs: { checkedChanged: "checkedChanged", selectedChanged: "selectedChanged", focusedChanged: "focusedChanged", itemClick: "itemClick", loadComplete: "loadComplete", itemsChanged: "itemsChanged", selectedIndexChange: "selectedIndexChange", checkedIndexChange: "checkedIndexChange", selectedIndicesChange: "selectedIndicesChange", checkedIndicesChange: "checkedIndicesChange" }, queries: [{ propertyName: "columnComponents", predicate: GcListBoxColumnComponent }], usesInheritance: true, ngImport: i0__namespace, template: "", isInline: true });
  __decorate([
      Property("", "", false, false),
      __metadata("design:type", Number)
  ], GcListBoxComponent.prototype, "selectedIndex", void 0);
  __decorate([
      Property("", "", false, false),
      __metadata("design:type", Number)
  ], GcListBoxComponent.prototype, "checkedIndex", void 0);
  __decorate([
      Property("", "", false, false),
      __metadata("design:type", Array)
  ], GcListBoxComponent.prototype, "selectedIndices", void 0);
  __decorate([
      Property("", "", false, false),
      __metadata("design:type", Array)
  ], GcListBoxComponent.prototype, "checkedIndices", void 0);
  __decorate([
      Property("resizeWidth"),
      __metadata("design:type", Object)
  ], GcListBoxComponent.prototype, "width", void 0);
  __decorate([
      Property("resizeHeight"),
      __metadata("design:type", Number)
  ], GcListBoxComponent.prototype, "height", void 0);
  __decorate([
      Property('setVisibleItemCount'),
      __metadata("design:type", Number)
  ], GcListBoxComponent.prototype, "visibleItems", void 0);
  i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcListBoxComponent, decorators: [{
              type: i0.Component,
              args: [{
                      selector: 'gc-list-box',
                      template: "",
                  }]
          }], ctorParameters: function () { return [{ type: i0__namespace.ElementRef }]; }, propDecorators: { items: [{
                  type: i0.Input
              }], columns: [{
                  type: i0.Input
              }], virtualMode: [{
                  type: i0.Input
              }], allowResize: [{
                  type: i0.Input
              }], selectionMode: [{
                  type: i0.Input
              }], selectedIndex: [{
                  type: i0.Input
              }], checkedIndex: [{
                  type: i0.Input
              }], selectedIndices: [{
                  type: i0.Input
              }], checkedIndices: [{
                  type: i0.Input
              }], allowColumnResize: [{
                  type: i0.Input
              }], overflow: [{
                  type: i0.Input
              }], width: [{
                  type: i0.Input
              }], height: [{
                  type: i0.Input
              }], itemHeight: [{
                  type: i0.Input
              }], checkOnClick: [{
                  type: i0.Input
              }], visibleItems: [{
                  type: i0.Input
              }], visible: [{
                  type: i0.Input
              }], enabled: [{
                  type: i0.Input
              }], showTip: [{
                  type: i0.Input
              }], multiColumn: [{
                  type: i0.Input
              }], colHeaderHeight: [{
                  type: i0.Input
              }], showHeader: [{
                  type: i0.Input
              }], valueMemberPath: [{
                  type: i0.Input
              }], displayMemberPath: [{
                  type: i0.Input
              }], showCheckBox: [{
                  type: i0.Input
              }], itemTemplate: [{
                  type: i0.Input
              }], headerTemplate: [{
                  type: i0.Input
              }], footerTemplate: [{
                  type: i0.Input
              }], emptyTemplate: [{
                  type: i0.Input
              }], load: [{
                  type: i0.Input
              }], pageSize: [{
                  type: i0.Input
              }], generatingItem: [{
                  type: i0.Input
              }], selectTemplate: [{
                  type: i0.Input
              }], formatItem: [{
                  type: i0.Input
              }], checkedChanged: [{
                  type: i0.Output
              }], selectedChanged: [{
                  type: i0.Output
              }], focusedChanged: [{
                  type: i0.Output
              }], itemClick: [{
                  type: i0.Output
              }], loadComplete: [{
                  type: i0.Output
              }], itemsChanged: [{
                  type: i0.Output
              }], selectedIndexChange: [{
                  type: i0.Output
              }], checkedIndexChange: [{
                  type: i0.Output
              }], selectedIndicesChange: [{
                  type: i0.Output
              }], checkedIndicesChange: [{
                  type: i0.Output
              }], columnComponents: [{
                  type: i0.ContentChildren,
                  args: [GcListBoxColumnComponent]
              }] } });

  var GcMaskComponent = /** @class */ (function (_super) {
      __extends(GcMaskComponent, _super);
      function GcMaskComponent(ref) {
          var _this = _super.call(this, ref) || this;
          _this.onTextChanging = new i0.EventEmitter();
          _this.onSpinDown = new i0.EventEmitter();
          _this.onSpinUp = new i0.EventEmitter();
          _this.onValueChanged = new i0.EventEmitter();
          // For V2.1 Compatibility, we have to keep this property or event
          _this.valueChange = new i0.EventEmitter();
          _this.valueIsFullChange = new i0.EventEmitter();
          return _this;
      }
      GcMaskComponent.prototype.writeValue = function (value) {
          this.value = value;
          if (this._imCtrl) {
              this._imCtrl.value = this.value;
          }
      };
      GcMaskComponent.prototype.registerOnChange = function (onChange) {
          this.onChange = onChange;
      };
      GcMaskComponent.prototype.registerOnTouched = function (onTouched) {
          this.onTouched = onTouched;
      };
      GcMaskComponent.prototype.setDisabledState = function (isDisabled) {
          this._imCtrl.enabled = !isDisabled;
      };
      GcMaskComponent.prototype.initGcComponent = function () {
          var input = document.createElement('input');
          this.createTemplate(input);
          this._imCtrl = new GC__namespace.InputMan.GcMask(input, this);
      };
      GcMaskComponent.prototype.bindEvent = function () {
          var _this = this;
          if (!this._imCtrl) {
              return;
          }
          _super.prototype.bindEvent.call(this);
          this._imCtrl.onInput(function (s) {
              _this.valueIsFullChange.emit(s.getValueIsFull());
          });
          this._imCtrl.onTextChanging(function (s, e) { _this.onTextChanging.emit({ sender: s, eArgs: e }); });
          this._imCtrl.onSpinDown(function (s) { _this.onSpinDown.emit(s); });
          this._imCtrl.onSpinUp(function (s) { _this.onSpinUp.emit(s); });
          this._imCtrl.onValueChanged(function (s) {
              _this.onValueChanged.emit(s);
              _this.onChange(s.getValue());
              _this.onTouched();
              _this.valueChange.emit(s.getValue());
              _this.valueIsFullChange.emit(s.getValueIsFull());
          });
      };
      return GcMaskComponent;
  }(GcInputManBaseComponent));
  GcMaskComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcMaskComponent, deps: [{ token: i0__namespace.ElementRef }], target: i0__namespace.ɵɵFactoryTarget.Component });
  GcMaskComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.17", type: GcMaskComponent, selector: "gc-mask", inputs: { autoConvert: "autoConvert", value: "value", formatPattern: "formatPattern", promptChar: "promptChar", showLiterals: "showLiterals", tabAction: "tabAction", text: "text", clipContent: "clipContent", allowSpin: "allowSpin", spinWheel: "spinWheel", spinOnKeys: "spinOnKeys", exitOnLastChar: "exitOnLastChar", highlightText: "highlightText", showSpinButton: "showSpinButton", spinButtonPosition: "spinButtonPosition", valueIsFull: "valueIsFull", showClearButton: "showClearButton" }, outputs: { onTextChanging: "onTextChanging", onSpinDown: "onSpinDown", onSpinUp: "onSpinUp", onValueChanged: "onValueChanged", valueChange: "valueChange", valueIsFullChange: "valueIsFullChange" }, providers: [
          provideParent(GcMaskComponent),
          {
              provide: forms.NG_VALUE_ACCESSOR,
              multi: true,
              useExisting: i0.forwardRef(function () { return GcMaskComponent; }),
          }
      ], usesInheritance: true, ngImport: i0__namespace, template: "", isInline: true });
  i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcMaskComponent, decorators: [{
              type: i0.Component,
              args: [{
                      selector: 'gc-mask',
                      template: "",
                      providers: [
                          provideParent(GcMaskComponent),
                          {
                              provide: forms.NG_VALUE_ACCESSOR,
                              multi: true,
                              useExisting: i0.forwardRef(function () { return GcMaskComponent; }),
                          }
                      ]
                  }]
          }], ctorParameters: function () { return [{ type: i0__namespace.ElementRef }]; }, propDecorators: { autoConvert: [{
                  type: i0.Input
              }], value: [{
                  type: i0.Input
              }], formatPattern: [{
                  type: i0.Input
              }], promptChar: [{
                  type: i0.Input
              }], showLiterals: [{
                  type: i0.Input
              }], tabAction: [{
                  type: i0.Input
              }], text: [{
                  type: i0.Input
              }], clipContent: [{
                  type: i0.Input
              }], allowSpin: [{
                  type: i0.Input
              }], spinWheel: [{
                  type: i0.Input
              }], spinOnKeys: [{
                  type: i0.Input
              }], exitOnLastChar: [{
                  type: i0.Input
              }], highlightText: [{
                  type: i0.Input
              }], showSpinButton: [{
                  type: i0.Input
              }], spinButtonPosition: [{
                  type: i0.Input
              }], valueIsFull: [{
                  type: i0.Input
              }], showClearButton: [{
                  type: i0.Input
              }], onTextChanging: [{
                  type: i0.Output
              }], onSpinDown: [{
                  type: i0.Output
              }], onSpinUp: [{
                  type: i0.Output
              }], onValueChanged: [{
                  type: i0.Output
              }], valueChange: [{
                  type: i0.Output
              }], valueIsFullChange: [{
                  type: i0.Output
              }] } });

  var GcMultilineTextBoxComponent = /** @class */ (function (_super) {
      __extends(GcMultilineTextBoxComponent, _super);
      function GcMultilineTextBoxComponent(ref) {
          var _this = _super.call(this, ref) || this;
          _this.onEditStatusChanged = new i0.EventEmitter();
          _this.onInvalidInput = new i0.EventEmitter();
          _this.onKeyExit = new i0.EventEmitter();
          _this.onTextChanged = new i0.EventEmitter();
          _this.onIMEReadingStringOutput = new i0.EventEmitter();
          _this.textChange = new i0.EventEmitter();
          // For V2.1 Compatibility, we have to keep this property or event
          _this.imeReadingStringChange = new i0.EventEmitter();
          return _this;
      }
      GcMultilineTextBoxComponent.prototype.writeValue = function (value) {
          this.text = value;
          if (this._imCtrl) {
              this._imCtrl.text = this.text;
          }
      };
      GcMultilineTextBoxComponent.prototype.registerOnChange = function (onChange) {
          this.onChange = onChange;
      };
      GcMultilineTextBoxComponent.prototype.registerOnTouched = function (onTouched) {
          this.onTouched = onTouched;
      };
      GcMultilineTextBoxComponent.prototype.setDisabledState = function (isDisabled) {
          this._imCtrl.enabled = !isDisabled;
      };
      GcMultilineTextBoxComponent.prototype.initGcComponent = function () {
          var element = document.createElement('textarea');
          this.createTemplate(element);
          this["IMEReadingStringAppend"] = this.imeReadingStringAppend;
          this["IMEReadingStringKanaMode"] = this.imeReadingStringKanaMode;
          this["IMEReadingStringEnableAlphabetReadingMapping"] = this.imeReadingStringEnableAlphabetReadingMapping;
          this._imCtrl = new GC__namespace.InputMan.GcMultiLineTextBox(element, this);
      };
      GcMultilineTextBoxComponent.prototype.bindEvent = function () {
          var _this = this;
          if (!this._imCtrl) {
              return;
          }
          _super.prototype.bindEvent.call(this);
          this._imCtrl.onTextChanged(function (s) {
              _this.onChange(s.getText());
              _this.onTouched();
          });
          this._imCtrl.onIMEReadingStringOutput(function (eventArgs) {
              _this.onIMEReadingStringOutput.emit(eventArgs);
              _this.imeReadingStringChange.emit(_this._imCtrl.getIMEReadingString());
          });
      };
      return GcMultilineTextBoxComponent;
  }(GcInputManBaseComponent));
  GcMultilineTextBoxComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcMultilineTextBoxComponent, deps: [{ token: i0__namespace.ElementRef }], target: i0__namespace.ɵɵFactoryTarget.Component });
  GcMultilineTextBoxComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.17", type: GcMultilineTextBoxComponent, selector: "gc-multiline-textbox", inputs: { countWrappedLine: "countWrappedLine", lengthAsByte: "lengthAsByte", maxLength: "maxLength", maxLineCount: "maxLineCount", imeReadingStringKanaMode: "imeReadingStringKanaMode", scrollBarMode: "scrollBarMode", scrollBars: "scrollBars", wordWrap: "wordWrap", acceptsReturn: "acceptsReturn", acceptsTab: "acceptsTab", imeReadingStringAppend: "imeReadingStringAppend", height: "height", imeReadingStringEnableAlphabetReadingMapping: "imeReadingStringEnableAlphabetReadingMapping", exitOnLastChar: "exitOnLastChar", highlightText: "highlightText", format: "format", autoConvert: "autoConvert", text: "text", lines: "lines", imeReadingString: "imeReadingString", cursorPosition: "cursorPosition" }, outputs: { onEditStatusChanged: "onEditStatusChanged", onInvalidInput: "onInvalidInput", onKeyExit: "onKeyExit", onTextChanged: "onTextChanged", onIMEReadingStringOutput: "onIMEReadingStringOutput", textChange: "textChange", imeReadingStringChange: "imeReadingStringChange" }, providers: [
          provideParent(GcMultilineTextBoxComponent),
          {
              provide: forms.NG_VALUE_ACCESSOR,
              multi: true,
              useExisting: i0.forwardRef(function () { return GcMultilineTextBoxComponent; }),
          }
      ], usesInheritance: true, ngImport: i0__namespace, template: "", isInline: true });
  __decorate([
      Property("setIMEReadingStringKanaMode"),
      __metadata("design:type", String)
  ], GcMultilineTextBoxComponent.prototype, "imeReadingStringKanaMode", void 0);
  __decorate([
      Property("setIMEReadingStringAppend"),
      __metadata("design:type", Boolean)
  ], GcMultilineTextBoxComponent.prototype, "imeReadingStringAppend", void 0);
  __decorate([
      Property("setIMEReadingStringEnableAlphabetReadingMapping"),
      __metadata("design:type", Boolean)
  ], GcMultilineTextBoxComponent.prototype, "imeReadingStringEnableAlphabetReadingMapping", void 0);
  i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcMultilineTextBoxComponent, decorators: [{
              type: i0.Component,
              args: [{
                      selector: 'gc-multiline-textbox',
                      template: "",
                      providers: [
                          provideParent(GcMultilineTextBoxComponent),
                          {
                              provide: forms.NG_VALUE_ACCESSOR,
                              multi: true,
                              useExisting: i0.forwardRef(function () { return GcMultilineTextBoxComponent; }),
                          }
                      ]
                  }]
          }], ctorParameters: function () { return [{ type: i0__namespace.ElementRef }]; }, propDecorators: { countWrappedLine: [{
                  type: i0.Input
              }], lengthAsByte: [{
                  type: i0.Input
              }], maxLength: [{
                  type: i0.Input
              }], maxLineCount: [{
                  type: i0.Input
              }], imeReadingStringKanaMode: [{
                  type: i0.Input
              }], scrollBarMode: [{
                  type: i0.Input
              }], scrollBars: [{
                  type: i0.Input
              }], wordWrap: [{
                  type: i0.Input
              }], acceptsReturn: [{
                  type: i0.Input
              }], acceptsTab: [{
                  type: i0.Input
              }], imeReadingStringAppend: [{
                  type: i0.Input
              }], height: [{
                  type: i0.Input
              }], imeReadingStringEnableAlphabetReadingMapping: [{
                  type: i0.Input
              }], exitOnLastChar: [{
                  type: i0.Input
              }], highlightText: [{
                  type: i0.Input
              }], format: [{
                  type: i0.Input
              }], autoConvert: [{
                  type: i0.Input
              }], text: [{
                  type: i0.Input
              }], lines: [{
                  type: i0.Input
              }], imeReadingString: [{
                  type: i0.Input
              }], cursorPosition: [{
                  type: i0.Input
              }], onEditStatusChanged: [{
                  type: i0.Output
              }], onInvalidInput: [{
                  type: i0.Output
              }], onKeyExit: [{
                  type: i0.Output
              }], onTextChanged: [{
                  type: i0.Output
              }], onIMEReadingStringOutput: [{
                  type: i0.Output
              }], textChange: [{
                  type: i0.Output
              }], imeReadingStringChange: [{
                  type: i0.Output
              }] } });

  var GcNumberComponent = /** @class */ (function (_super) {
      __extends(GcNumberComponent, _super);
      function GcNumberComponent(ref) {
          var _this = _super.call(this, ref) || this;
          _this.onSpinDown = new i0.EventEmitter();
          _this.onSpinUp = new i0.EventEmitter();
          _this.onInvalidRange = new i0.EventEmitter();
          _this.onValueChanged = new i0.EventEmitter();
          // For V2.1 Compatibility, we have to keep this property or event
          _this.valueChange = new i0.EventEmitter();
          return _this;
      }
      GcNumberComponent.prototype.writeValue = function (value) {
          this.value = value;
          if (this._imCtrl) {
              this._imCtrl.value = this.value;
          }
      };
      GcNumberComponent.prototype.registerOnChange = function (onChange) {
          this.onChange = onChange;
      };
      GcNumberComponent.prototype.registerOnTouched = function (onTouched) {
          this.onTouched = onTouched;
      };
      GcNumberComponent.prototype.setDisabledState = function (isDisabled) {
          this._imCtrl.enabled = !isDisabled;
      };
      GcNumberComponent.prototype.initGcComponent = function () {
          var element = document.createElement('input');
          this.createTemplate(element);
          this._imCtrl = new GC__namespace.InputMan.GcNumber(element, this);
      };
      GcNumberComponent.prototype.bindEvent = function () {
          var _this = this;
          if (!this._imCtrl) {
              return;
          }
          _super.prototype.bindEvent.call(this);
          this._imCtrl.onSpinDown(function (s) { _this.onSpinDown.emit(s); });
          this._imCtrl.onSpinUp(function (s) { _this.onSpinUp.emit(s); });
          this._imCtrl.onInvalidRange(function (s) { _this.onInvalidRange.emit(s); });
          this._imCtrl.onValueChanged(function (s) {
              _this.onValueChanged.emit(s);
              _this.onChange(s.getValue());
              _this.onTouched();
              _this.valueChange.emit(s.getValue());
          });
      };
      GcNumberComponent.prototype.clear = function () {
          return this._imCtrl.clear();
      };
      return GcNumberComponent;
  }(GcInputManBaseComponent));
  GcNumberComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcNumberComponent, deps: [{ token: i0__namespace.ElementRef }], target: i0__namespace.ɵɵFactoryTarget.Component });
  GcNumberComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.17", type: GcNumberComponent, selector: "gc-number", inputs: { value: "value", text: "text", watermarkZeroText: "watermarkZeroText", formatDigit: "formatDigit", displayPositivePrefix: "displayPositivePrefix", displayFormatDigit: "displayFormatDigit", maxValue: "maxValue", minValue: "minValue", positivePrefix: "positivePrefix", positiveSuffix: "positiveSuffix", displayPositiveSuffix: "displayPositiveSuffix", negativePrefix: "negativePrefix", displayNegativePrefix: "displayNegativePrefix", negativeSuffix: "negativeSuffix", displayNegativeSuffix: "displayNegativeSuffix", valueSign: "valueSign", adjustValueOnFocus: "adjustValueOnFocus", allowDeleteToNull: "allowDeleteToNull", clearAction: "clearAction", acceptsDecimal: "acceptsDecimal", currencySymbol: "currencySymbol", decimalPoint: "decimalPoint", maxMinBehavior: "maxMinBehavior", separator: "separator", watermarkDisplayZeroText: "watermarkDisplayZeroText", highlightText: "highlightText", allowSpin: "allowSpin", spinWheel: "spinWheel", spinOnKeys: "spinOnKeys", spinWrap: "spinWrap", showSpinButton: "showSpinButton", spinButtonPosition: "spinButtonPosition", showNumericPad: "showNumericPad", numericPadPosition: "numericPadPosition", showCalculatorAsDropDown: "showCalculatorAsDropDown", showCalculatorAsPopup: "showCalculatorAsPopup", calculatorButtonPosition: "calculatorButtonPosition", dropDownConfig: "dropDownConfig", showClearButton: "showClearButton" }, outputs: { onSpinDown: "onSpinDown", onSpinUp: "onSpinUp", onInvalidRange: "onInvalidRange", onValueChanged: "onValueChanged", valueChange: "valueChange" }, providers: [
          provideParent(GcNumberComponent),
          {
              provide: forms.NG_VALUE_ACCESSOR,
              multi: true,
              useExisting: i0.forwardRef(function () { return GcNumberComponent; }),
          }
      ], usesInheritance: true, ngImport: i0__namespace, template: "", isInline: true });
  i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcNumberComponent, decorators: [{
              type: i0.Component,
              args: [{
                      selector: 'gc-number',
                      template: "",
                      providers: [
                          provideParent(GcNumberComponent),
                          {
                              provide: forms.NG_VALUE_ACCESSOR,
                              multi: true,
                              useExisting: i0.forwardRef(function () { return GcNumberComponent; }),
                          }
                      ]
                  }]
          }], ctorParameters: function () { return [{ type: i0__namespace.ElementRef }]; }, propDecorators: { value: [{
                  type: i0.Input
              }], text: [{
                  type: i0.Input
              }], watermarkZeroText: [{
                  type: i0.Input
              }], formatDigit: [{
                  type: i0.Input
              }], displayPositivePrefix: [{
                  type: i0.Input
              }], displayFormatDigit: [{
                  type: i0.Input
              }], maxValue: [{
                  type: i0.Input
              }], minValue: [{
                  type: i0.Input
              }], positivePrefix: [{
                  type: i0.Input
              }], positiveSuffix: [{
                  type: i0.Input
              }], displayPositiveSuffix: [{
                  type: i0.Input
              }], negativePrefix: [{
                  type: i0.Input
              }], displayNegativePrefix: [{
                  type: i0.Input
              }], negativeSuffix: [{
                  type: i0.Input
              }], displayNegativeSuffix: [{
                  type: i0.Input
              }], valueSign: [{
                  type: i0.Input
              }], adjustValueOnFocus: [{
                  type: i0.Input
              }], allowDeleteToNull: [{
                  type: i0.Input
              }], clearAction: [{
                  type: i0.Input
              }], acceptsDecimal: [{
                  type: i0.Input
              }], currencySymbol: [{
                  type: i0.Input
              }], decimalPoint: [{
                  type: i0.Input
              }], maxMinBehavior: [{
                  type: i0.Input
              }], separator: [{
                  type: i0.Input
              }], watermarkDisplayZeroText: [{
                  type: i0.Input
              }], highlightText: [{
                  type: i0.Input
              }], allowSpin: [{
                  type: i0.Input
              }], spinWheel: [{
                  type: i0.Input
              }], spinOnKeys: [{
                  type: i0.Input
              }], spinWrap: [{
                  type: i0.Input
              }], showSpinButton: [{
                  type: i0.Input
              }], spinButtonPosition: [{
                  type: i0.Input
              }], showNumericPad: [{
                  type: i0.Input
              }], numericPadPosition: [{
                  type: i0.Input
              }], showCalculatorAsDropDown: [{
                  type: i0.Input
              }], showCalculatorAsPopup: [{
                  type: i0.Input
              }], calculatorButtonPosition: [{
                  type: i0.Input
              }], dropDownConfig: [{
                  type: i0.Input
              }], showClearButton: [{
                  type: i0.Input
              }], onSpinDown: [{
                  type: i0.Output
              }], onSpinUp: [{
                  type: i0.Output
              }], onInvalidRange: [{
                  type: i0.Output
              }], onValueChanged: [{
                  type: i0.Output
              }], valueChange: [{
                  type: i0.Output
              }] } });

  var GcShortcutInfoComponent = /** @class */ (function () {
      function GcShortcutInfoComponent() {
      }
      return GcShortcutInfoComponent;
  }());
  GcShortcutInfoComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcShortcutInfoComponent, deps: [], target: i0__namespace.ɵɵFactoryTarget.Component });
  GcShortcutInfoComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.17", type: GcShortcutInfoComponent, selector: "gc-shortcut-info", inputs: { shortcutKey: "shortcutKey", shift: "shift", ctrl: "ctrl", alt: "alt", target: "target", action: "action", blockMessage: "blockMessage" }, ngImport: i0__namespace, template: "", isInline: true });
  i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcShortcutInfoComponent, decorators: [{
              type: i0.Component,
              args: [{
                      selector: 'gc-shortcut-info',
                      template: ""
                  }]
          }], propDecorators: { shortcutKey: [{
                  type: i0.Input
              }], shift: [{
                  type: i0.Input
              }], ctrl: [{
                  type: i0.Input
              }], alt: [{
                  type: i0.Input
              }], target: [{
                  type: i0.Input
              }], action: [{
                  type: i0.Input
              }], blockMessage: [{
                  type: i0.Input
              }] } });
  var GcShortcutComponent = /** @class */ (function (_super) {
      __extends(GcShortcutComponent, _super);
      function GcShortcutComponent(ref) {
          var _this = _super.call(this, ref) || this;
          _this.preAction = new i0.EventEmitter();
          _this.postAction = new i0.EventEmitter();
          return _this;
      }
      GcShortcutComponent.prototype.initGcComponent = function () {
          var _this = this;
          this._imCtrl = new GC__namespace.InputMan.GcShortcut();
          if (this.shortcutInfoList && this.shortcutInfoList.length > 0) {
              this.shortcutInfoList.forEach(function (info) {
                  var target = _this.tryGetTarget(info.target);
                  if (target === null)
                      return;
                  var args = Object.assign(Object.assign({}, info), { key: info.shortcutKey, target: target });
                  _this._imCtrl.add(args);
              });
          }
      };
      GcShortcutComponent.prototype.tryGetTarget = function (str) {
          if (str === undefined)
              return window;
          var el = document.querySelector(str);
          if (el === null)
              return null;
          return el[IMCtrl] || el;
      };
      GcShortcutComponent.prototype.bindEvent = function () {
          var _this = this;
          if (!this._imCtrl)
              return;
          this._imCtrl.addEventListener(GC__namespace.InputMan.GcShortcutEvent.PreAction, function (s, e) {
              _this.preAction.emit(e);
          });
          this._imCtrl.addEventListener(GC__namespace.InputMan.GcShortcutEvent.PostAction, function (s, e) {
              _this.postAction.emit(e);
          });
      };
      return GcShortcutComponent;
  }(GcComponents));
  GcShortcutComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcShortcutComponent, deps: [{ token: i0__namespace.ElementRef }], target: i0__namespace.ɵɵFactoryTarget.Component });
  GcShortcutComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.17", type: GcShortcutComponent, selector: "gc-shortcut", inputs: { blockMessage: "blockMessage", triggerAll: "triggerAll" }, outputs: { preAction: "preAction", postAction: "postAction" }, queries: [{ propertyName: "shortcutInfoList", predicate: GcShortcutInfoComponent }], usesInheritance: true, ngImport: i0__namespace, template: "", isInline: true });
  i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcShortcutComponent, decorators: [{
              type: i0.Component,
              args: [{
                      selector: 'gc-shortcut',
                      template: ""
                  }]
          }], ctorParameters: function () { return [{ type: i0__namespace.ElementRef }]; }, propDecorators: { blockMessage: [{
                  type: i0.Input
              }], triggerAll: [{
                  type: i0.Input
              }], shortcutInfoList: [{
                  type: i0.ContentChildren,
                  args: [GcShortcutInfoComponent]
              }], preAction: [{
                  type: i0.Output
              }], postAction: [{
                  type: i0.Output
              }] } });

  var GcSoftKeyboardComponent = /** @class */ (function (_super) {
      __extends(GcSoftKeyboardComponent, _super);
      function GcSoftKeyboardComponent(ref) {
          var _this = _super.call(this, ref) || this;
          _this.onOpen = new i0.EventEmitter();
          _this.onClose = new i0.EventEmitter();
          _this.onKeyPress = new i0.EventEmitter();
          return _this;
      }
      GcSoftKeyboardComponent.prototype.initGcComponent = function () {
          var element = document.createElement('div');
          this.createTemplate(element);
          this._imCtrl = new GC__namespace.InputMan.GcSoftKeyboard(element, this);
          this.setTarget(this.target);
          this.setOpened(this.opened);
      };
      GcSoftKeyboardComponent.prototype.bindEvent = function () {
          var _this = this;
          if (!this._imCtrl)
              return;
          this._imCtrl.addEventListener(GC__namespace.InputMan.GcSoftKeyboardEvent.KeyPress, function (s, e) {
              _this.onKeyPress.emit(e);
          });
          this._imCtrl.addEventListener(GC__namespace.InputMan.GcSoftKeyboardEvent.Open, function (s) {
              _this.onOpen.emit(s);
          });
          this._imCtrl.addEventListener(GC__namespace.InputMan.GcSoftKeyboardEvent.Close, function (s) {
              _this.onClose.emit(s);
          });
      };
      GcSoftKeyboardComponent.prototype.setValueToIMControl = function (key, value) {
          if (key === 'opened') {
              this.setOpened(value);
          }
          else if (key === 'target') {
              this.setTarget(value);
          }
          else {
              _super.prototype.setValueToIMControl.call(this, key, value);
          }
      };
      GcSoftKeyboardComponent.prototype.setOpened = function (opened) {
          if (opened === true) {
              this._imCtrl.open();
          }
          else if (opened === false) {
              this._imCtrl.close();
          }
      };
      GcSoftKeyboardComponent.prototype.setTarget = function (str) {
          var target = this.tryGetTarget(str);
          if (target) {
              this._imCtrl.target = target;
          }
      };
      GcSoftKeyboardComponent.prototype.tryGetTarget = function (str) {
          try {
              var target = document.querySelector(str);
              return target;
          }
          catch (_a) { }
          return null;
      };
      return GcSoftKeyboardComponent;
  }(GcComponents));
  GcSoftKeyboardComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcSoftKeyboardComponent, deps: [{ token: i0__namespace.ElementRef }], target: i0__namespace.ɵɵFactoryTarget.Component });
  GcSoftKeyboardComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.17", type: GcSoftKeyboardComponent, selector: "gc-soft-keyboard", inputs: { opened: "opened", randomDisplay: "randomDisplay", hideButtonWhenMouseOn: "hideButtonWhenMouseOn", displayType: "displayType", showSecurityOptions: "showSecurityOptions", securityLevel: "securityLevel", qwertyLayout: "qwertyLayout", showCapitalLetters: "showCapitalLetters", target: "target", enabled: "enabled" }, outputs: { onOpen: "onOpen", onClose: "onClose", onKeyPress: "onKeyPress" }, usesInheritance: true, ngImport: i0__namespace, template: "", isInline: true });
  i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcSoftKeyboardComponent, decorators: [{
              type: i0.Component,
              args: [{
                      selector: 'gc-soft-keyboard',
                      template: ""
                  }]
          }], ctorParameters: function () { return [{ type: i0__namespace.ElementRef }]; }, propDecorators: { opened: [{
                  type: i0.Input
              }], randomDisplay: [{
                  type: i0.Input
              }], hideButtonWhenMouseOn: [{
                  type: i0.Input
              }], displayType: [{
                  type: i0.Input
              }], showSecurityOptions: [{
                  type: i0.Input
              }], securityLevel: [{
                  type: i0.Input
              }], qwertyLayout: [{
                  type: i0.Input
              }], showCapitalLetters: [{
                  type: i0.Input
              }], target: [{
                  type: i0.Input
              }], enabled: [{
                  type: i0.Input
              }], onOpen: [{
                  type: i0.Output
              }], onClose: [{
                  type: i0.Output
              }], onKeyPress: [{
                  type: i0.Output
              }] } });

  var GcTextBoxComponent = /** @class */ (function (_super) {
      __extends(GcTextBoxComponent, _super);
      function GcTextBoxComponent(ref) {
          var _this = _super.call(this, ref) || this;
          _this.onIMEReadingStringOutput = new i0.EventEmitter();
          // For V2.1 Compatibility, we have to keep this property or event
          _this.imeReadingStringChange = new i0.EventEmitter();
          return _this;
      }
      GcTextBoxComponent.prototype.writeValue = function (value) {
          this.text = value;
          if (this._imCtrl) {
              this._imCtrl.text = this.text;
          }
      };
      GcTextBoxComponent.prototype.registerOnChange = function (onChange) {
          this.onChange = onChange;
      };
      GcTextBoxComponent.prototype.registerOnTouched = function (onTouched) {
          this.onTouched = onTouched;
      };
      GcTextBoxComponent.prototype.setDisabledState = function (isDisabled) {
          this._imCtrl.enabled = !isDisabled;
      };
      GcTextBoxComponent.prototype.initGcComponent = function () {
          var input = document.createElement("input");
          this.createTemplate(input);
          this["IMEReadingStringAppend"] = this.imeReadingStringAppend;
          this["IMEReadingStringKanaMode"] = this.imeReadingStringKanaMode;
          this["IMEReadingStringEnableAlphabetReadingMapping"] = this.imeReadingStringEnableAlphabetReadingMapping;
          this._imCtrl = new GC__namespace.InputMan.GcTextBox(input, this);
      };
      GcTextBoxComponent.prototype.bindEvent = function () {
          var _this = this;
          if (!this._imCtrl) {
              return;
          }
          _super.prototype.bindEvent.call(this);
          this._imCtrl.onTextChanged(function (s) {
              _this.onTouched();
              _this.onChange(s.getText());
          });
          this._imCtrl.onIMEReadingStringOutput(function (s, e) {
              _this.onIMEReadingStringOutput.emit({ sender: s, eArgs: e });
              _this.imeReadingStringChange.emit(s.getIMEReadingString());
          });
      };
      return GcTextBoxComponent;
  }(GcInputManBaseComponent));
  GcTextBoxComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcTextBoxComponent, deps: [{ token: i0__namespace.ElementRef }], target: i0__namespace.ɵɵFactoryTarget.Component });
  GcTextBoxComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.17", type: GcTextBoxComponent, selector: "gc-text-box", inputs: { autoConvert: "autoConvert", ellipsisString: "ellipsisString", ellipsis: "ellipsis", format: "format", lengthAsByte: "lengthAsByte", maxLength: "maxLength", passwordChar: "passwordChar", text: "text", useSystemPasswordChar: "useSystemPasswordChar", imeReadingStringAppend: "imeReadingStringAppend", imeReadingStringKanaMode: "imeReadingStringKanaMode", imeReadingStringEnableAlphabetReadingMapping: "imeReadingStringEnableAlphabetReadingMapping", exitOnLastChar: "exitOnLastChar", highlightText: "highlightText", imeReadingString: "imeReadingString", showClearButton: "showClearButton", passwordRevelationMode: "passwordRevelationMode" }, outputs: { onIMEReadingStringOutput: "onIMEReadingStringOutput", imeReadingStringChange: "imeReadingStringChange" }, providers: [
          provideParent(GcTextBoxComponent),
          {
              provide: forms.NG_VALUE_ACCESSOR,
              multi: true,
              useExisting: i0.forwardRef(function () { return GcTextBoxComponent; }),
          }
      ], usesInheritance: true, ngImport: i0__namespace, template: "", isInline: true });
  __decorate([
      Property("setIMEReadingStringAppend"),
      __metadata("design:type", Boolean)
  ], GcTextBoxComponent.prototype, "imeReadingStringAppend", void 0);
  __decorate([
      Property("setIMEReadingStringKanaMode"),
      __metadata("design:type", String)
  ], GcTextBoxComponent.prototype, "imeReadingStringKanaMode", void 0);
  __decorate([
      Property("setIMEReadingStringEnableAlphabetReadingMapping"),
      __metadata("design:type", Boolean)
  ], GcTextBoxComponent.prototype, "imeReadingStringEnableAlphabetReadingMapping", void 0);
  i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcTextBoxComponent, decorators: [{
              type: i0.Component,
              args: [{
                      selector: 'gc-text-box',
                      template: "",
                      providers: [
                          provideParent(GcTextBoxComponent),
                          {
                              provide: forms.NG_VALUE_ACCESSOR,
                              multi: true,
                              useExisting: i0.forwardRef(function () { return GcTextBoxComponent; }),
                          }
                      ]
                  }]
          }], ctorParameters: function () { return [{ type: i0__namespace.ElementRef }]; }, propDecorators: { autoConvert: [{
                  type: i0.Input
              }], ellipsisString: [{
                  type: i0.Input
              }], ellipsis: [{
                  type: i0.Input
              }], format: [{
                  type: i0.Input
              }], lengthAsByte: [{
                  type: i0.Input
              }], maxLength: [{
                  type: i0.Input
              }], passwordChar: [{
                  type: i0.Input
              }], text: [{
                  type: i0.Input
              }], useSystemPasswordChar: [{
                  type: i0.Input
              }], imeReadingStringAppend: [{
                  type: i0.Input
              }], imeReadingStringKanaMode: [{
                  type: i0.Input
              }], imeReadingStringEnableAlphabetReadingMapping: [{
                  type: i0.Input
              }], exitOnLastChar: [{
                  type: i0.Input
              }], highlightText: [{
                  type: i0.Input
              }], imeReadingString: [{
                  type: i0.Input
              }], showClearButton: [{
                  type: i0.Input
              }], passwordRevelationMode: [{
                  type: i0.Input
              }], onIMEReadingStringOutput: [{
                  type: i0.Output
              }], imeReadingStringChange: [{
                  type: i0.Output
              }] } });

  var GcTipNotifierComponent = /** @class */ (function (_super) {
      __extends(GcTipNotifierComponent, _super);
      function GcTipNotifierComponent(ref, _parent) {
          var _this = _super.call(this, ref) || this;
          _this._parent = _parent;
          return _this;
      }
      GcTipNotifierComponent.prototype.ngAfterViewInit = function () {
          if (!this._parent || typeof this._parent !== 'object' ||
              typeof this._parent.getNestedIMControl() !== 'object') {
              return;
          }
          this._imCtrl = new GC__namespace.InputMan.GcTipNotifier(this._parent.getNestedIMControl(), this);
          this.onInitialized.emit(this._imCtrl);
      };
      GcTipNotifierComponent.prototype.bindEvent = function () { };
      GcTipNotifierComponent.prototype.initGcComponent = function () {
      };
      GcTipNotifierComponent.prototype.onFail = function () {
          return this._imCtrl.onFail();
      };
      GcTipNotifierComponent.prototype.onSuccess = function () {
          return this._imCtrl.onSuccess();
      };
      GcTipNotifierComponent.prototype.onClear = function () {
          return this._imCtrl.onClear();
      };
      return GcTipNotifierComponent;
  }(GcComponents));
  GcTipNotifierComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcTipNotifierComponent, deps: [{ token: i0__namespace.ElementRef }, { token: GcComponents, optional: true }], target: i0__namespace.ɵɵFactoryTarget.Component });
  GcTipNotifierComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.17", type: GcTipNotifierComponent, selector: "gc-tip-notifier", inputs: { direction: "direction", position: "position", directionPriority: "directionPriority", template: "template", failMessage: "failMessage", successMessage: "successMessage", tipState: "tipState" }, usesInheritance: true, ngImport: i0__namespace, template: "", isInline: true });
  i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: GcTipNotifierComponent, decorators: [{
              type: i0.Component,
              args: [{
                      selector: 'gc-tip-notifier',
                      template: "",
                  }]
          }], ctorParameters: function () {
          return [{ type: i0__namespace.ElementRef }, { type: GcComponents, decorators: [{
                          type: i0.Optional
                      }] }];
      }, propDecorators: { direction: [{
                  type: i0.Input
              }], position: [{
                  type: i0.Input
              }], directionPriority: [{
                  type: i0.Input
              }], template: [{
                  type: i0.Input
              }], failMessage: [{
                  type: i0.Input
              }], successMessage: [{
                  type: i0.Input
              }], tipState: [{
                  type: i0.Input
              }] } });

  /*Import from angular */
  /**
   *  Declare & add export modules
   */
  var InputManModule = /** @class */ (function () {
      function InputManModule() {
      }
      return InputManModule;
  }());
  InputManModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: InputManModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
  InputManModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: InputManModule, declarations: [GcMaskComponent,
          GcTextBoxComponent,
          GcCalendarComponent,
          GcNumberComponent,
          GcDateTimeComponent,
          GcListBoxComponent,
          GcComboBoxComponent,
          GcDateTimePickerComponent,
          GcTipNotifierComponent,
          GcIconNotifierComponent,
          GcMultilineTextBoxComponent,
          GcComboBoxColumnComponent,
          GcListBoxColumnComponent,
          GcFormPersistenceComponent,
          GcCalculatorComponent,
          GcFunctionKeyComponent,
          GcFunctionKeyInfoComponent,
          GcShortcutComponent,
          GcShortcutInfoComponent,
          GcSoftKeyboardComponent], imports: [common.CommonModule,
          forms.FormsModule], exports: [GcMaskComponent,
          GcTextBoxComponent,
          GcCalendarComponent,
          GcNumberComponent,
          GcDateTimeComponent,
          GcListBoxComponent,
          GcComboBoxComponent,
          GcDateTimePickerComponent,
          GcTipNotifierComponent,
          GcIconNotifierComponent,
          GcMultilineTextBoxComponent,
          GcComboBoxColumnComponent,
          GcListBoxColumnComponent,
          GcFormPersistenceComponent,
          GcCalculatorComponent,
          GcFunctionKeyComponent,
          GcFunctionKeyInfoComponent,
          GcShortcutComponent,
          GcShortcutInfoComponent,
          GcSoftKeyboardComponent] });
  InputManModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: InputManModule, imports: [[
              common.CommonModule,
              forms.FormsModule
          ]] });
  i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: InputManModule, decorators: [{
              type: i0.NgModule,
              args: [{
                      imports: [
                          common.CommonModule,
                          forms.FormsModule
                      ],
                      declarations: [
                          GcMaskComponent,
                          GcTextBoxComponent,
                          GcCalendarComponent,
                          GcNumberComponent,
                          GcDateTimeComponent,
                          GcListBoxComponent,
                          GcComboBoxComponent,
                          GcDateTimePickerComponent,
                          GcTipNotifierComponent,
                          GcIconNotifierComponent,
                          GcMultilineTextBoxComponent,
                          GcComboBoxColumnComponent,
                          GcListBoxColumnComponent,
                          GcFormPersistenceComponent,
                          GcCalculatorComponent,
                          GcFunctionKeyComponent,
                          GcFunctionKeyInfoComponent,
                          GcShortcutComponent,
                          GcShortcutInfoComponent,
                          GcSoftKeyboardComponent,
                      ],
                      exports: [
                          GcMaskComponent,
                          GcTextBoxComponent,
                          GcCalendarComponent,
                          GcNumberComponent,
                          GcDateTimeComponent,
                          GcListBoxComponent,
                          GcComboBoxComponent,
                          GcDateTimePickerComponent,
                          GcTipNotifierComponent,
                          GcIconNotifierComponent,
                          GcMultilineTextBoxComponent,
                          GcComboBoxColumnComponent,
                          GcListBoxColumnComponent,
                          GcFormPersistenceComponent,
                          GcCalculatorComponent,
                          GcFunctionKeyComponent,
                          GcFunctionKeyInfoComponent,
                          GcShortcutComponent,
                          GcShortcutInfoComponent,
                          GcSoftKeyboardComponent
                      ]
                  }]
          }] });

  /**
   * Generated bundle index. Do not edit.
   */

  exports.GcCalculatorComponent = GcCalculatorComponent;
  exports.GcCalendarComponent = GcCalendarComponent;
  exports.GcComboBoxColumnComponent = GcComboBoxColumnComponent;
  exports.GcComboBoxComponent = GcComboBoxComponent;
  exports.GcDateTimeComponent = GcDateTimeComponent;
  exports.GcDateTimePickerComponent = GcDateTimePickerComponent;
  exports.GcFormPersistenceComponent = GcFormPersistenceComponent;
  exports.GcFunctionKeyComponent = GcFunctionKeyComponent;
  exports.GcFunctionKeyInfoComponent = GcFunctionKeyInfoComponent;
  exports.GcIconNotifierComponent = GcIconNotifierComponent;
  exports.GcListBoxColumnComponent = GcListBoxColumnComponent;
  exports.GcListBoxComponent = GcListBoxComponent;
  exports.GcMaskComponent = GcMaskComponent;
  exports.GcMultilineTextBoxComponent = GcMultilineTextBoxComponent;
  exports.GcNumberComponent = GcNumberComponent;
  exports.GcShortcutComponent = GcShortcutComponent;
  exports.GcShortcutInfoComponent = GcShortcutInfoComponent;
  exports.GcSoftKeyboardComponent = GcSoftKeyboardComponent;
  exports.GcTextBoxComponent = GcTextBoxComponent;
  exports.GcTipNotifierComponent = GcTipNotifierComponent;
  exports.InputManModule = InputManModule;

  Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=grapecity-inputman.angular.umd.js.map
