import { ElementRef, EventEmitter } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import * as GC from '@grapecity/inputman';
import { GcInputManBaseComponent } from './GcInputManBase';
import * as i0 from "@angular/core";
export declare class GcDateTimeComponent extends GcInputManBaseComponent<GC.InputMan.GcDateTime> implements ControlValueAccessor {
    constructor(ref: ElementRef);
    private onChange;
    private onTouched;
    writeValue(value: any): void;
    registerOnChange(onChange: any): void;
    registerOnTouched(onTouched: any): void;
    setDisabledState(isDisabled: boolean): void;
    protected initGcComponent(): void;
    text: string | null;
    number: number;
    maxDate: Date | string | null;
    minDate: Date | string | null;
    formatPattern: string | null;
    spinIncrement: number;
    spinOnKeys: boolean;
    spinWrap: boolean;
    allowSpin: boolean;
    spinWheel: boolean;
    displayFormatPattern: string | null;
    watermarkEmptyEraText: string | null;
    promptChar: string | null;
    AMDesignator: string | null;
    PMDesignator: string | null;
    twoDigitYearMax: number;
    hour12Mode: GC.InputMan.Hour12Mode;
    tabAction: GC.InputMan.TabAction;
    maxMinBehavior: GC.InputMan.MaxMinBehavior;
    midnightAs24: boolean;
    showLiterals: GC.InputMan.ShowLiterals;
    adjustValueOnFocus: boolean;
    useTwoDigitYearMax: boolean;
    validateMode: GC.InputMan.ValidateMode;
    clipContent: GC.InputMan.ClipContent;
    value: Date | string;
    watermarkDisplayEmptyEraText: string | null;
    dropDownConfig: GC.InputMan.GcDateTimeDropDownConfig;
    exitOnLastChar: boolean;
    highlightText: GC.InputMan.HighlightText;
    showSpinButton: boolean;
    spinButtonPosition: string | null;
    showDropDownButton: boolean;
    dropDownButtonAlignment: string | null;
    showClearButton: boolean;
    onSpinDown: EventEmitter<object>;
    onSpinUp: EventEmitter<object>;
    onInvalidRange: EventEmitter<object>;
    onInvalidValue: EventEmitter<object>;
    onNumberChanged: EventEmitter<object>;
    onValueChanged: EventEmitter<object>;
    numberChange: EventEmitter<number>;
    valueChange: EventEmitter<Date>;
    protected bindEvent(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<GcDateTimeComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<GcDateTimeComponent, "gc-datetime", never, { "text": "text"; "number": "number"; "maxDate": "maxDate"; "minDate": "minDate"; "formatPattern": "formatPattern"; "spinIncrement": "spinIncrement"; "spinOnKeys": "spinOnKeys"; "spinWrap": "spinWrap"; "allowSpin": "allowSpin"; "spinWheel": "spinWheel"; "displayFormatPattern": "displayFormatPattern"; "watermarkEmptyEraText": "watermarkEmptyEraText"; "promptChar": "promptChar"; "AMDesignator": "AMDesignator"; "PMDesignator": "PMDesignator"; "twoDigitYearMax": "twoDigitYearMax"; "hour12Mode": "hour12Mode"; "tabAction": "tabAction"; "maxMinBehavior": "maxMinBehavior"; "midnightAs24": "midnightAs24"; "showLiterals": "showLiterals"; "adjustValueOnFocus": "adjustValueOnFocus"; "useTwoDigitYearMax": "useTwoDigitYearMax"; "validateMode": "validateMode"; "clipContent": "clipContent"; "value": "value"; "watermarkDisplayEmptyEraText": "watermarkDisplayEmptyEraText"; "dropDownConfig": "dropDownConfig"; "exitOnLastChar": "exitOnLastChar"; "highlightText": "highlightText"; "showSpinButton": "showSpinButton"; "spinButtonPosition": "spinButtonPosition"; "showDropDownButton": "showDropDownButton"; "dropDownButtonAlignment": "dropDownButtonAlignment"; "showClearButton": "showClearButton"; }, { "onSpinDown": "onSpinDown"; "onSpinUp": "onSpinUp"; "onInvalidRange": "onInvalidRange"; "onInvalidValue": "onInvalidValue"; "onNumberChanged": "onNumberChanged"; "onValueChanged": "onValueChanged"; "numberChange": "numberChange"; "valueChange": "valueChange"; }, never, never>;
}
