import { ElementRef, EventEmitter } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import * as GC from '@grapecity/inputman';
import { GcInputManBaseComponent } from './GcInputManBase';
import * as i0 from "@angular/core";
export declare class GcTextBoxComponent extends GcInputManBaseComponent<GC.InputMan.GcTextBox> implements ControlValueAccessor {
    constructor(ref: ElementRef);
    private onChange;
    private onTouched;
    writeValue(value: any): void;
    registerOnChange(onChange: any): void;
    registerOnTouched(onTouched: any): void;
    setDisabledState(isDisabled: boolean): void;
    autoConvert: boolean;
    ellipsisString: string | null;
    ellipsis: GC.InputMan.EllipsisMode;
    format: string | null;
    lengthAsByte: boolean;
    maxLength: number;
    passwordChar: string | null;
    text: string | null;
    useSystemPasswordChar: boolean;
    imeReadingStringAppend: boolean;
    imeReadingStringKanaMode: GC.InputMan.KanaMode;
    imeReadingStringEnableAlphabetReadingMapping: boolean;
    exitOnLastChar: boolean;
    highlightText: boolean;
    imeReadingString: string;
    showClearButton: boolean;
    passwordRevelationMode: GC.InputMan.PasswordRevelationMode;
    onIMEReadingStringOutput: EventEmitter<object>;
    imeReadingStringChange: EventEmitter<string>;
    protected initGcComponent(): void;
    protected bindEvent(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<GcTextBoxComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<GcTextBoxComponent, "gc-text-box", never, { "autoConvert": "autoConvert"; "ellipsisString": "ellipsisString"; "ellipsis": "ellipsis"; "format": "format"; "lengthAsByte": "lengthAsByte"; "maxLength": "maxLength"; "passwordChar": "passwordChar"; "text": "text"; "useSystemPasswordChar": "useSystemPasswordChar"; "imeReadingStringAppend": "imeReadingStringAppend"; "imeReadingStringKanaMode": "imeReadingStringKanaMode"; "imeReadingStringEnableAlphabetReadingMapping": "imeReadingStringEnableAlphabetReadingMapping"; "exitOnLastChar": "exitOnLastChar"; "highlightText": "highlightText"; "imeReadingString": "imeReadingString"; "showClearButton": "showClearButton"; "passwordRevelationMode": "passwordRevelationMode"; }, { "onIMEReadingStringOutput": "onIMEReadingStringOutput"; "imeReadingStringChange": "imeReadingStringChange"; }, never, never>;
}
