import { OnChanges, OnDestroy, AfterContentInit, ElementRef, SimpleChanges, EventEmitter } from '@angular/core';
import { PropertyDictionary } from '../common';
import * as i0 from "@angular/core";
export declare function provideParent(component: any): {
    provide: typeof GcComponents;
    useExisting: import("@angular/core").Type<any>;
};
export declare abstract class GcComponents<T extends object> implements OnChanges, AfterContentInit, OnDestroy {
    protected _container: Element;
    protected _imCtrl: T;
    propDic: PropertyDictionary;
    constructor(ref: ElementRef);
    ngOnChanges(changes: SimpleChanges): void;
    protected setValueToIMControl(key: string, value: any): void;
    private isSetAccessor;
    ngOnDestroy(): void;
    ngAfterContentInit(): void;
    protected abstract initGcComponent(): void;
    protected abstract bindEvent(): void;
    private tryGetPropertyOperator;
    private hasRealMethod;
    getNestedIMControl(): T;
    createTemplate(element: HTMLElement): void;
    name: string;
    onInitialized: EventEmitter<object>;
    static ɵfac: i0.ɵɵFactoryDeclaration<GcComponents<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<GcComponents<any>, "ng-component", never, { "name": "name"; }, { "onInitialized": "onInitialized"; }, never, never>;
}
