import { ElementRef, EventEmitter } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import * as GC from '@grapecity/inputman';
import { GcInputManBaseComponent } from './GcInputManBase';
import * as i0 from "@angular/core";
export declare class GcMaskComponent extends GcInputManBaseComponent<GC.InputMan.GcMask> implements ControlValueAccessor {
    constructor(ref: ElementRef);
    private onChange;
    private onTouched;
    writeValue(value: any): void;
    registerOnChange(onChange: any): void;
    registerOnTouched(onTouched: any): void;
    setDisabledState(isDisabled: boolean): void;
    autoConvert: boolean;
    value: string | null;
    formatPattern: string;
    promptChar: string;
    showLiterals: GC.InputMan.ShowLiterals;
    tabAction: GC.InputMan.TabAction;
    text: string;
    clipContent: GC.InputMan.ClipContent;
    allowSpin: boolean;
    spinWheel: boolean;
    spinOnKeys: boolean;
    exitOnLastChar: boolean;
    highlightText: string;
    showSpinButton: boolean;
    spinButtonPosition: GC.InputMan.SpinButtonAlignment;
    valueIsFull: boolean;
    showClearButton: boolean;
    onTextChanging: EventEmitter<object>;
    onSpinDown: EventEmitter<object>;
    onSpinUp: EventEmitter<object>;
    onValueChanged: EventEmitter<object>;
    valueChange: EventEmitter<string>;
    valueIsFullChange: EventEmitter<boolean>;
    protected initGcComponent(): void;
    protected bindEvent(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<GcMaskComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<GcMaskComponent, "gc-mask", never, { "autoConvert": "autoConvert"; "value": "value"; "formatPattern": "formatPattern"; "promptChar": "promptChar"; "showLiterals": "showLiterals"; "tabAction": "tabAction"; "text": "text"; "clipContent": "clipContent"; "allowSpin": "allowSpin"; "spinWheel": "spinWheel"; "spinOnKeys": "spinOnKeys"; "exitOnLastChar": "exitOnLastChar"; "highlightText": "highlightText"; "showSpinButton": "showSpinButton"; "spinButtonPosition": "spinButtonPosition"; "valueIsFull": "valueIsFull"; "showClearButton": "showClearButton"; }, { "onTextChanging": "onTextChanging"; "onSpinDown": "onSpinDown"; "onSpinUp": "onSpinUp"; "onValueChanged": "onValueChanged"; "valueChange": "valueChange"; "valueIsFullChange": "valueIsFullChange"; }, never, never>;
}
