import { ElementRef, EventEmitter } from '@angular/core';
import * as GC from '@grapecity/inputman';
import { GcComponents } from './GcComponents';
import * as i0 from "@angular/core";
export declare class GcSoftKeyboardComponent extends GcComponents<GC.InputMan.GcSoftKeyboard> {
    opened?: boolean;
    randomDisplay?: boolean;
    hideButtonWhenMouseOn?: boolean;
    displayType?: GC.InputMan.DisplayType | null;
    showSecurityOptions?: boolean;
    securityLevel?: GC.InputMan.SecurityLevel | null;
    qwertyLayout?: boolean;
    showCapitalLetters?: boolean;
    target?: string;
    enabled?: boolean;
    onOpen?: EventEmitter<object>;
    onClose?: EventEmitter<object>;
    onKeyPress?: EventEmitter<object>;
    constructor(ref: ElementRef);
    protected initGcComponent(): void;
    protected bindEvent(): void;
    protected setValueToIMControl(key: string, value: any): void;
    private setOpened;
    private setTarget;
    private tryGetTarget;
    static ɵfac: i0.ɵɵFactoryDeclaration<GcSoftKeyboardComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<GcSoftKeyboardComponent, "gc-soft-keyboard", never, { "opened": "opened"; "randomDisplay": "randomDisplay"; "hideButtonWhenMouseOn": "hideButtonWhenMouseOn"; "displayType": "displayType"; "showSecurityOptions": "showSecurityOptions"; "securityLevel": "securityLevel"; "qwertyLayout": "qwertyLayout"; "showCapitalLetters": "showCapitalLetters"; "target": "target"; "enabled": "enabled"; }, { "onOpen": "onOpen"; "onClose": "onClose"; "onKeyPress": "onKeyPress"; }, never, never>;
}
